/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.service.auth;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;


/**
 *
 * @author 564685
 */
public class ServiceAuditDAO {
    @PersistenceContext(name = "VapEntityManager")
    private EntityManager em;

    public void setEntityManager(EntityManager entityManager) {
        this.em = entityManager;
    }
    public Long create(final ServiceAudit sa)
            throws Exception {
        try {
            this.em.persist(sa);
        } catch (final Exception ex) {
            throw ex;
        }
        return sa.getID();
    }

    public ServiceAudit findServiceAudit(final Long id) {
        return this.em.find(ServiceAudit.class, id);
    }

    public List<ServiceAudit> findServiceAuditByExternalService(final String cn) {
        try {
            final Query q = this.em
                    .createNamedQuery("ServiceAudit.findServiceAuditByCN");
            q.setParameter("cn", cn);
            return (List<ServiceAudit>) q.getResultList();
        } catch (final NoResultException nre) {
            return new ArrayList<ServiceAudit>();
        }
    }
    public List<ServiceAudit> findServiceAuditByWebService(final String webservice) {
        try {
            final Query q = this.em
                    .createNamedQuery("ServiceAudit.findServiceAuditByWebService");
            q.setParameter("webService", webservice);
            return (List<ServiceAudit>) q.getResultList();
        } catch (final NoResultException nre) {
            return new ArrayList<ServiceAudit>();
        }
    }
}
