/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.service.forms;



import java.util.List;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;

/**
 * 
 * @author vhaislegberb
 */
@WebService
public interface FormsStorageService {

	/**
	 * Business method for adding a new partner organization to the VAP system.
	 * This could also be the point at which further (down-stream) on-boarding
	 * activities could be triggered to notify other systems of the changes to
	 * the supported partners.
	 * 
	 * @param partner
	 *            The partner to be added.
	 * @param announce
	 *            Whether to announce all patients to the new partner or not.
	 * @throws PartnerOnboardingException
	 *             In the event that the partner could not be added.
	 */
	@WebMethod
        @WebResult(name="DocID")
	Long addPatientForm(@WebParam(name = "patientID") final String patientID,
			@WebParam(name = "document") final String document,
                        @WebParam(name = "documentType") final String documentType)
			throws FormsStorageException;

	/**
	 * Sets the partner as active if the activate flag is set to true; otherwise
	 * set the partner to inactive.
	 * 
	 * @param activate
	 * @param oid
	 *            The OID of the partner which is being activated or
	 *            deactivated..
	 * @throws PartnerOnboardingException
	 *             In the event that the setting of the status flag fails.
	 */
	@WebMethod
        @WebResult(name="FormList")
	List<Long> getPatientFormIDs(@WebParam(name = "patientID") final String patientID,
                        @WebParam(name = "documentType") final String documentType)
			throws FormsStorageException;
        
        /**
	 * Sets the partner as active if the activate flag is set to true; otherwise
	 * set the partner to inactive.
	 * 
	 * @param activate
	 * @param oid
	 *            The OID of the partner which is being activated or
	 *            deactivated..
	 * @throws PartnerOnboardingException
	 *             In the event that the setting of the status flag fails.
	 */
	@WebMethod
        @WebResult(name="PatientForm")
	PatientForm getPatientForm(@WebParam(name = "docID") final Long docID)
			throws FormsStorageException;
        
        /**
	 * Sets the partner as active if the activate flag is set to true; otherwise
	 * set the partner to inactive.
	 * 
	 * @param activate
	 * @param oid
	 *            The OID of the partner which is being activated or
	 *            deactivated..
	 * @throws PartnerOnboardingException
	 *             In the event that the setting of the status flag fails.
	 */
	@WebMethod
        @WebResult(name="PatientForm")
	PatientForm getLatestPatientForm(@WebParam(name = "patientID") final String patientID,
                        @WebParam(name = "documentType") final String documentType)
			throws FormsStorageException;
        

}
