package gov.va.nvap.web.consent.comment;

import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Johann Sonnenberg
 */
public class ConsentCommentDAO {
    
    /**
    * Entity Manager instance.
    */
    @PersistenceContext
    private EntityManager em;
    
    @Transactional
    public ConsentComment create(ConsentComment comment) {
        em.persist(comment);
        return comment;
    }
   
   public List<ConsentComment> getCommentsByConsentIds(List<Long> consentIds) {
       Query query = em.createQuery("SELECT c FROM ConsentComment c WHERE c.consentId IN (:consentIds) ORDER BY c.dateAdded ASC");
       query.setParameter("consentIds", consentIds);
       
       return (List<ConsentComment>) query.getResultList();
   }
   
    /**
     * Set the entity manager (Injected by Spring).
     */
    public void setEntityManager(final EntityManager em) {
        this.em = em;
    }
}