/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.web.report;

import gov.va.nvap.common.validation.NullChecker;
import gov.va.nvap.web.app.ResponseDispatcherHttpServlet;
import gov.va.nvap.web.helper.facility.FacilityHelper;
import gov.va.nvap.web.helper.privacy.ConsentManagementHelper;
import gov.va.nvap.web.util.Paginator;
import gov.va.nvap.web.util.date.DateUtil;
import gov.va.nvap.web.visn.Visn;

import java.io.IOException;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.ArrayList;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * @author 
 * edited by               
 */
public class OptInOptOutReport extends ResponseDispatcherHttpServlet {
	/**
	 * Serial UID.
	 */
	private static final long serialVersionUID = 3721503355079491829L;

	/**
	 * Entity Manager instance.
	 */
	@PersistenceContext
	private EntityManager em;

	/**
	 * Get the CMS helper from Spring.
	 */
	public ConsentManagementHelper getCmsHelper() {
		final ConsentManagementHelper cmsHelper = this.getBean("cmsHelper",
				ConsentManagementHelper.class);
		return cmsHelper;
	}

	/**
	 * Get the facility helper from Spring.
	 */
	public FacilityHelper getFacilityHelper() {
		final FacilityHelper facilityHelper = this.getBean("facilityHelper",
				FacilityHelper.class);
		return facilityHelper;
	}

	/**
	 * Set the entity manager (Injected by Spring).
	 */
	public void setEntityManager(final EntityManager em) {
		this.em = em;
	}

	public void search(final HttpServletRequest request,
			final HttpServletResponse response) throws ServletException,
			IOException {
		final HttpSession session = request.getSession(false);
		final String startDate = request.getParameter("startDate");
		final String endDate = request.getParameter("endDate");
		final String ssn = request.getParameter("ssn");
		final String firstName = request.getParameter("firstName");
		final String lastName = request.getParameter("lastName");
		//final String actionType = request.getParameter("actionType");
		final String facilityName = request.getParameter("facility");
		final String visnName = request.getParameter("visn");
		final String defaultFacility = request.getParameter("defaultFacility");
		final String inactivationReason = request.getParameter("inactivationReason");
		final String consentType = request.getParameter("consentType");
                final String consentTypeName = request.getParameter("consentTypeName");
		final int recordsPerPage = Integer.parseInt(request
				.getParameter("recordsPerPage"));
		final String enteredBy = request.getParameter("enteredBy");
		//final String testDataOnly = request.getParameter("testDataOnly");
		final boolean testPatients = "testPatients".equals(request
				.getParameter("testPatients"));
			
		if (this.validate(request, response, "search")) {
			ReportDataProcessor.setStartAndEndDates(session, startDate, endDate, "optInOptOutQuery");

			session.setAttribute("paginator", new Paginator(recordsPerPage));
			session.setAttribute("optInOptOutQueryFirstName", firstName);
			session.setAttribute("optInOptOutQueryLastName", lastName);
			session.setAttribute("optInOptOutQuerySsn", ssn);
			session.setAttribute("optInOptOutQueryConsentType", consentType);
                        session.setAttribute("optInOptOutQueryConsentTypeName", consentTypeName);
			session.setAttribute("optInOptOutQueryFacilityName", facilityName);
			session.setAttribute("optInOptOutQueryVisnName", visnName);
			session.setAttribute("inactivationReason", inactivationReason);
			session.setAttribute("testPatients", testPatients);
			session.setAttribute("enteredBy", enteredBy);
			// Just to be safe
			session.removeAttribute("optInOptOutQueryICN");

			//TODO remove references to cookies.2-23-2012
			if (!NullChecker.isNullOrEmpty(defaultFacility)
					&& defaultFacility.equalsIgnoreCase("ON")) {
				response.addCookie(this.setFacilityCookie(facilityName));
			}
			
			/*if (!NullChecker.isNullOrEmpty(testDataOnly)
					&& testDataOnly.equalsIgnoreCase("ON")) {
				session.setAttribute("testDataOnly", true);
				// TODO communicate to adapter to only use test data
			}else{
				session.setAttribute("testDataOnly", false);
			}*/
			
			this.forward(request, response, "success");
		} else {
			this.forward(request, response, "validate");
		}
	}

	/**
	 * If the URL starts with redirect: then redirect to a different location
	 * with the same parameters.
	 */
	private Cookie setFacilityCookie(final String setFacility) {

		Cookie vapCookie = null;

		if (setFacility != null) {
			if (setFacility.equals("")) {
				vapCookie = new Cookie("facility", "");
				vapCookie.setMaxAge(0);
			} else {
				vapCookie = new Cookie("facility", setFacility);
				vapCookie.setMaxAge(5 * 365 * 24 * 60 * 60);
			}

			// vapCookie.setPath("/");
			// vapCookie.setDomain("localhost:7001/nhin_vap_web");
		}
		return vapCookie;
	}

	@Override
	protected void unspecified(final HttpServletRequest request,
			final HttpServletResponse response) throws ServletException,
			IOException {
		final HttpSession session = request.getSession(false);
		session.removeAttribute("optInOptOutQueryfirstName");
		session.removeAttribute("optInOptOutQuerylastName");
		session.removeAttribute("optInOptOutQuerySsn");
		session.removeAttribute("optInOptOutQueryActionType");
		session.removeAttribute("optInOptOutQueryConsentType");
		session.removeAttribute("optInOptOutQueryFacilityName");
		session.removeAttribute("optInOptOutQueryVisnName");
		session.removeAttribute("optInOptOutQueryStartDate");
		session.removeAttribute("optInOptOutQueryICN");
		session.removeAttribute("optInOptOutQueryEndDate");
		session.removeAttribute("testPatients");
		session.removeAttribute("paginator");
		session.removeAttribute("optInOptOutResults");
		
		request.setAttribute("facilities", this.getFacilityHelper()
				.getAllVistAFacilities());
		request.setAttribute("optOutReasons", this.getCmsHelper()
				.getOptoutReasons());
                
                // send over the list of all VISNs
                Query query = this.em.createNamedQuery("Visn.findAll");
                Collection<Visn> visns = query.getResultList();
                request.setAttribute("visns", visns);
                
		// Get the Default Facility by user id
		/*
		final gov.va.nvap.svc.facility.data.Facility defaultUserFacility = 
			this.getFacilityHelper().getFacilityStationByVHAUserId(request.getRemoteUser());
		if (NullChecker.isNotEmpty(defaultUserFacility)) {
			session.setAttribute("defaultUserFacility",
					defaultUserFacility);
		}
		*/
		
		final gov.va.nvap.svc.facility.data.Facility defaultUserFacility = 
			(gov.va.nvap.svc.facility.data.Facility) session.getAttribute("defaultUserFacility");

		this.forward(request, response, "show");
	}
}
