/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.web.report;

import gov.va.nvap.common.validation.NullChecker;
import gov.va.nvap.web.app.ResponseDispatcherHttpServlet;
import gov.va.nvap.web.helper.facility.FacilityHelper;
import gov.va.nvap.web.util.Paginator;
import gov.va.nvap.web.util.date.DateUtil;

import java.io.IOException;
import java.util.Calendar;
import java.util.Date;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * @author 
 * edited by               
 */
public class OptInOptOutSummaryReport extends ResponseDispatcherHttpServlet {
	/**
	 * Serial UID.
	 */
	private static final long serialVersionUID = 3721503355079491829L;

	/**
	 * Get the facility helper from Spring.
	 */
	public FacilityHelper getFacilityHelper() {
		final FacilityHelper facilityHelper = this.getBean("facilityHelper",
				FacilityHelper.class);
		return facilityHelper;
	}

	public void search(final HttpServletRequest request,
			final HttpServletResponse response) throws ServletException,
			IOException {
		final HttpSession session = request.getSession(false);
		final String startDate = request.getParameter("startDate");
		final String endDate = request.getParameter("endDate");
		final String actionType = request.getParameter("actionType");
		final String facility = request.getParameter("facility");
		final String consentType = request.getParameter("consentType");
                final String consentTypeName = request.getParameter("consentTypeName");
		final boolean testPatients = "testPatients".equals(request
				.getParameter("testPatients"));
		final String defaultFacility = request.getParameter("defaultFacility");
		//final String testDataOnly = request.getParameter("testDataOnly");

		if (this.validate(request, response, "search")) {
			ReportDataProcessor.setStartAndEndDates(session, startDate, endDate, "optInOptOutSummaryQuery");

			session.setAttribute("testPatients", testPatients);
			session.setAttribute("optInOptOutSummaryQueryActionType",
					actionType);
			session.setAttribute("optInOptOutSummaryQueryFacilityName", facility);

			if (!NullChecker.isNullOrEmpty(defaultFacility)
					&& defaultFacility.equalsIgnoreCase("ON")) {
				response.addCookie(this.setFacilityCookie(facility));
			}

			session.setAttribute("consentType", consentType);
			session.setAttribute("consentTypeName", consentTypeName);
			/*if (!NullChecker.isNullOrEmpty(testDataOnly)
					&& testDataOnly.equalsIgnoreCase("ON")) {
				session.setAttribute("testDataOnly", true);
				// TODO communicate to adapter to only use test data
			}else{
				session.setAttribute("testDataOnly", false);
			}*/
			
			this.forward(request, response, "success");
		} else {
			this.forward(request, response, "validate");
		}
	}

	/**
	 * If the URL starts with redirect: then redirect to a different location
	 * with the same parameters.
	 */
	private Cookie setFacilityCookie(final String setFacility) {

		Cookie vapCookie = null;

		if (setFacility != null) {
			if (setFacility.equals("")) {
				vapCookie = new Cookie("facility", "");
				vapCookie.setMaxAge(0);
			} else {
				vapCookie = new Cookie("facility", setFacility);
				vapCookie.setMaxAge(5 * 365 * 24 * 60 * 60);
			}

			// vapCookie.setPath("/");
			// vapCookie.setDomain("localhost:7001/nhin_vap_web");
		}
		return vapCookie;
	}

	@Override
	protected void unspecified(final HttpServletRequest request,
			final HttpServletResponse response) throws ServletException,
			IOException {
		final HttpSession session = request.getSession(false);
		session.removeAttribute("optInOptOutSummaryQueryActionType");
		session.removeAttribute("optInOptOutSummaryQueryFacilityName");
		session.removeAttribute("optInOptOutSummaryQueryStartDate");
		session.removeAttribute("optInOptOutSummaryQueryEndDate");
		session.removeAttribute("testPatients");
		session.removeAttribute("paginator");
		session.removeAttribute("optInOptOutSummaryResults");
		session.removeAttribute("nwhinAuthorizationTotal");
		session.removeAttribute("ssaAuthorizationTotal");
		session.removeAttribute("nwhinRevocationTotal");
		session.removeAttribute("ssaRevocationTotal");
		session.removeAttribute("nwhinRestrictionTotal");
		session.removeAttribute("nwhinRestrictionRevocationTotal");
		session.removeAttribute("consentType");
		
		request.setAttribute("facilities", this.getFacilityHelper()
				.getAllVistAFacilities());

		// Get the Default Facility by user id
		/*
		final gov.va.nvap.svc.facility.data.Facility defaultUserFacility = 
			this.getFacilityHelper().getFacilityStationByVHAUserId(request.getRemoteUser());
		if (NullChecker.isNotEmpty(defaultUserFacility)) {
			session.setAttribute("defaultUserFacility",
					defaultUserFacility);
		}
		*/
		
		final gov.va.nvap.svc.facility.data.Facility defaultUserFacility = 
			(gov.va.nvap.svc.facility.data.Facility) session.getAttribute("defaultUserFacility");
		
		this.forward(request, response, "show");
	}
}
