/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.web.report;

import gov.va.nvap.common.validation.NullChecker;
import gov.va.nvap.privacy.ConsentType;
import gov.va.nvap.web.app.ResponseDispatcherHttpServlet;
import gov.va.nvap.web.consent.audit.AuditedConsentSummary;
import gov.va.nvap.web.consent.audit.dao.AuditedConsentDAO;
import gov.va.nvap.web.helper.document.DocumentHelper;
import gov.va.nvap.web.helper.facility.FacilityHelper;
import gov.va.nvap.web.helper.report.ReportHelper;
import gov.va.nvap.web.util.Constants;
import gov.va.nvap.web.util.Paginator;
import gov.va.nvap.web.util.xls.ExcelExporter;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.LinkedHashMap; 

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.poi.ss.usermodel.Workbook;
/**
 * @author 
 * edited by               
 * edited by                  
 */
public class OptInOptOutSummaryReportResults extends
		ResponseDispatcherHttpServlet {

	/**
	 * Serial UID.
	 */
	private static final long serialVersionUID = -1131510956121479062L;

	/**
	 * Export to excel - This method is called when the user clicks on the excel
	 * icon in the JSP. Reflection is used in the ResponseDispatcherHttpServlet
	 * to call this method based on the http parameters.
	 * 
	 * @param request
	 *            HTTP Request
	 * @param response
	 *            HTTP Response
	 * @throws ServletException
	 * @throws IOException
	 */
/*		
uncomment this method and excel icon in corresponding jsp to re-enable excel reporting
*/ 
	public void exportToExcel(final HttpServletRequest request,
			final HttpServletResponse response) throws ServletException,
			IOException {
		// Get the session
		final HttpSession session = request.getSession(false);
		// Get the results from the adapter with the paginator set to -1 (all
		// results)
		final List<Map<String, Object>> results = this.getResults( request.getSession());
				//request.getSession(), new Paginator(-1));                                
		// Create a map of key which is based on the result data key and the
                // heading value
                // The heading is used to create the column headers and the key is used
                // to pull the data from the results
                final Map<String, String> consentDirectiveSummaryMap = new LinkedHashMap<String, String>();
		// Set the optional rows
		final Object nwhinAuthorizationTotal = session
				.getAttribute("nwhinAuthorizationTotal");
		final Object ssaAuthorizationTotal = session
				.getAttribute("ssaAuthorizationTotal");
		final Object nwhinRevocationTotal = session
				.getAttribute("nwhinRevocationTotal");
		final Object ssaRevocationTotal = session
				.getAttribute("ssaRevocationTotal");
		final Object nwhinRestrictionTotal = session
				.getAttribute("nwhinRestrictionTotal");
		final Object nwhinRestrictionRevocationTotal = session
				.getAttribute("nwhinRestrictionRevocationTotal");
		final Map<String, List<Object>> optionalRows = new LinkedHashMap<String, List<Object>>();
		final List<Object> nwhinAuthorizationRow = new ArrayList<Object>();
		nwhinAuthorizationRow.add(nwhinAuthorizationTotal);
		final List<Object> ssaAuthorizationRow = new ArrayList<Object>();
		ssaAuthorizationRow.add(ssaAuthorizationTotal);
		final List<Object> nwhinRevocationRow = new ArrayList<Object>();
		nwhinRevocationRow.add(nwhinRevocationTotal);
		final List<Object> ssaRevocationRow = new ArrayList<Object>();
		ssaRevocationRow.add(ssaRevocationTotal);
		final List<Object> nwhinRestrictionRow = new ArrayList<Object>();
		nwhinRestrictionRow.add(nwhinRestrictionTotal);
		final List<Object> nwhinRestrictionRevocationRow = new ArrayList<Object>();
		nwhinRestrictionRevocationRow.add(nwhinRestrictionRevocationTotal);
		optionalRows.put("Grand Total eHealth Exchange Authorizations:", nwhinAuthorizationRow);
		optionalRows.put("Grand Total SSA Authorizations:", ssaAuthorizationRow);
		optionalRows.put("Grand Total eHealth Exchange Revocations:", nwhinRevocationRow);
		optionalRows.put("Grand Total SSA Revocations:", ssaRevocationRow);
		optionalRows.put("Grand Total eHealth Exchange Restrictions:", nwhinRestrictionRow);
		optionalRows.put("Grand Total eHealth Exchange Restriction Revocations:", nwhinRestrictionRevocationRow);
		
		
		// Set the heading parameters
		final Map<String, List<Object>> headingParameters = new LinkedHashMap<String, List<Object>>();
                LinkedHashMap<String,Object> filters = new LinkedHashMap<String,Object>();
                //List all the possible optional filters for Consent Directive Summary Report
                filters.put("Start Date", this.getReportHelper().getFormattedDate((Date)session.getAttribute("optInOptOutSummaryQueryStartDate")));
                filters.put("End Date", this.getReportHelper().getFormattedDate((Date)session.getAttribute("optInOptOutSummaryQueryEndDate")));
                filters.put("VA Facility", session.getAttribute("optInOptOutSummaryQueryFacilityName"));
                filters.put("Consent Type", session.getAttribute("consentTypeName"));
		//Iterate through the possible filters and remove empty filters.
                for (Map.Entry<String,Object> filter : filters.entrySet()){
                    String filterName = filter.getKey();
                    Object value = filter.getValue();
                    List<Object> headingValue = new ArrayList<Object>();
                    if (!(value == null) && !("".equals(value)) && !("Unknown".equals(value))){
                        headingValue.add(value);
                        headingParameters.put(filterName, headingValue);
                    }
                }    

                if ((Boolean)session.getAttribute("testPatients")){
                    List<Object> headingValue = new ArrayList<Object>();
                    headingValue.add("Yes");
                    headingParameters.put("Include test patients", headingValue);
                }
                
                if (NullChecker.isNullOrEmpty(results)){
                    consentDirectiveSummaryMap.put("", "No records were found.");
                }
                
                else {
                    consentDirectiveSummaryMap.put("facilityName", "VA Facility");
                    consentDirectiveSummaryMap.put("consentType", "Consent Type");
                    consentDirectiveSummaryMap.put("count", "Total");
                }
                
		// Create workbook
		final Workbook wb = this.getExcelExporter().exportToExcel(
				"Consent Directive Summary Report",
				"Consent Directive Summary Report", consentDirectiveSummaryMap,
				results, headingParameters, optionalRows);
		// Write Excel to Stream
		this.getExcelExporter().writeExcelToStream(wb, response);
	}

	public DocumentHelper getDocumentHelper() {
		return this.getBean("adapterDocumentHelper", DocumentHelper.class);
	}

	/**
	 * Get the excel exporter class from Spring.
	 * 
	 * @return the excel exporter object
	 */
	public ExcelExporter getExcelExporter() {
		final ExcelExporter excelExporter = this.getBean("excelExporter",
				ExcelExporter.class);
		return excelExporter;
	}

	/**
	 * Get the facility helper from Spring.
	 */
	public FacilityHelper getFacilityHelper() {
		return this.getBean("facilityHelper", FacilityHelper.class);
	}

	public ReportHelper getReportHelper() {
		final ReportHelper reportHelper = this.getBean("reportHelper",
				ReportHelper.class);
		return reportHelper;
	}
	
	private List<Map<String, Object>> getResults(final HttpSession session) 
            throws ServletException {

		final String patientFacility = (String) session
				.getAttribute("optInOptOutSummaryQueryFacilityName");
//		final String actionType = (String) session
//				.getAttribute("optInOptOutSummaryQueryActionType");
		final String consentTypeSearch = (String) session.getAttribute("consentType");
		final Date sd = (Date) session
				.getAttribute("optInOptOutSummaryQueryStartDate");
		final Date ed = (Date) session
				.getAttribute("optInOptOutSummaryQueryEndDate");
		final Boolean includeTestPatients = (Boolean) session
				.getAttribute("testPatients");
		//Long optInCount = new Long(0);
		//Long optOutCount = new Long(0);
		long nA = 0;
		long sA = 0;
		long nR = 0;
		long sR = 0;
		long nRe = 0;
		long nReRe = 0;
		Long nwhinAuthorizationTotal = new Long(nA);
		Long ssaAuthorizationTotal = new Long(sA);
		Long nwhinRevocationTotal = new Long(nR);
		Long ssaRevocationTotal = new Long(sR);
		Long nwhinRestrictionTotal = new Long(nRe);
		Long nwhinRestrictionRevocationTotal = new Long(nReRe);
		
		final String optInOptOutSummaryReportSortValue = (String) session
				.getAttribute("optInOptOutSummaryReportSortValue");
		final String optInOptOutSummaryReportSortDirection = (String) session
				.getAttribute("optInOptOutSummaryReportSortDirection");

		final AuditedConsentDAO auditedConsentDAO = this.getBean(
				"auditedConsentDAO", AuditedConsentDAO.class);
		List<AuditedConsentSummary> auditedConsentSummaryList = null;

		// -1 indicates all results
		auditedConsentSummaryList = auditedConsentDAO.getEventsSummary(sd,
					ed, patientFacility, consentTypeSearch, -1, -1,
					optInOptOutSummaryReportSortValue,
					optInOptOutSummaryReportSortDirection, includeTestPatients);
		

		final List<Map<String, Object>> results = new ArrayList<Map<String, Object>>();
		for (final AuditedConsentSummary auditSummary : auditedConsentSummaryList) {

			final Map<String, Object> resultMap = new HashMap<String, Object>();
			
            String displayConsentType = auditSummary.getConsentType();
            if (displayConsentType.contains("NwHIN")) {
                displayConsentType = displayConsentType.replace("NwHIN", Constants.getOrganizationName());
            }
            resultMap.put("consentType", displayConsentType);
			//final String facility = this.getFacilityHelper()
			//		.getFacilityNameByStationId(auditSummary.getFacility());
			//resultMap.put("facilityName", ReportDataProcessor.fixStation(facility));
			resultMap.put("facilityName", ReportDataProcessor.fixStation(auditSummary.getFacility()));
			resultMap.put("count", auditSummary.getCount());
            
			//TODO use consentType.java
			String consentType = auditSummary.getConsentType();
			ConsentType ct = ConsentType.fromValue(consentType);
			switch(ct) {
			case NW_HIN_AUTHORIZATION:
				nwhinAuthorizationTotal += auditSummary.getCount();
				break;
			case NW_HIN_REVOCATION:
				nwhinRevocationTotal += auditSummary.getCount();
				break;
			case SSA_AUTHORIZATION:
				ssaAuthorizationTotal += auditSummary.getCount();
				break;
			case SSA_REVOCATION:
				ssaRevocationTotal += auditSummary.getCount();
				break;
			case NW_HIN_ORGANIZATION_RESTRICTION_AUTHORIZATION:
				nwhinRestrictionTotal += auditSummary.getCount();
				break;
			case NW_HIN_ORGANIZATION_RESTRICTION_REVOCATION:
				nwhinRestrictionRevocationTotal += auditSummary.getCount();
				break;
			default:
					try {
						throw new Exception("unrecognized consent type: "+consentType);
					} catch (Exception e) {
						e.printStackTrace();
					}
				break;
			}			
			results.add(resultMap);
        }
		session.setAttribute("nwhinAuthorizationTotal", nwhinAuthorizationTotal);
		session.setAttribute("ssaAuthorizationTotal", ssaAuthorizationTotal);
		session.setAttribute("nwhinRevocationTotal", nwhinRevocationTotal);
		session.setAttribute("ssaRevocationTotal", ssaRevocationTotal);
		session.setAttribute("nwhinRestrictionTotal", nwhinRestrictionTotal);
		session.setAttribute("nwhinRestrictionRevocationTotal", nwhinRestrictionRevocationTotal);
		
		if (NullChecker.isEmpty(auditedConsentSummaryList)) {
			return results;
		}
		
		session.setAttribute("optInOptOutSummaryReportSortValue",
				optInOptOutSummaryReportSortValue);
		session.setAttribute("optInOptOutSummaryReportSortDirection",
				optInOptOutSummaryReportSortDirection);

		return results;
	}

	@Override
	public void unspecified(final HttpServletRequest request,
			final HttpServletResponse response) throws ServletException,
			IOException {
		final HttpSession session = request.getSession(false);

		final String optInOptOutSummaryReportSortValue = request
				.getParameter("optInOptOutSummaryReportSortValue");
		final String optInOptOutSummaryReportSortDirection = request
				.getParameter("optInOptOutSummaryReportSortDirection");
		session.setAttribute("optInOptOutSummaryReportSortValue",
				optInOptOutSummaryReportSortValue);
		session.setAttribute("optInOptOutSummaryReportSortDirection",
				optInOptOutSummaryReportSortDirection);
        
        session.setAttribute("optInOptOutSummaryResults", this.getResults(session));
			this.forward(request, response, "show");
	}

}
