/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.web.report;

import gov.va.nvap.common.validation.NullChecker;
import gov.va.nvap.web.app.ResponseDispatcherHttpServlet;
import gov.va.nvap.web.helper.privacy.ConsentManagementHelper;
import gov.va.nvap.web.util.Paginator;
import gov.va.nvap.web.util.date.DateUtil;

import java.io.IOException;
import java.util.Date;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * @author Asha Amritraj
 */
public class PatientDiscoveryReport extends ResponseDispatcherHttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = -8614673990226997234L;

	public ConsentManagementHelper getCmsHelper() {
		final ConsentManagementHelper cmsHelper = this.getBean("cmsHelper",
				ConsentManagementHelper.class);
		return cmsHelper;
	}

	public void search(final HttpServletRequest request,
			final HttpServletResponse response) throws ServletException,
			IOException {
		final HttpSession session = request.getSession(false);
        final String ssn = request.getParameter("ssn");
        final String lastName = request.getParameter("lastName");
        final String firstName = request.getParameter("firstName");
		final String startDate = request.getParameter("startDate");
		final String endDate = request.getParameter("endDate");
		final String organization = request.getParameter("organization");
                final String organizationName = request.getParameter("organizationName");
		final String mpiMatch = request.getParameter("mpiMatch");
		final int recordsPerPage = Integer.parseInt(request
				.getParameter("recordsPerPage"));
		//final String testDataOnly = request.getParameter("testDataOnly");
		//final String purposeOfUse = request.getParameter("purposeOfUse");
		final boolean testPatients = "testPatients".equals(request
				.getParameter("testPatients"));
		final String patientDiscoverySortValue = request
				.getParameter("patientDiscoverySortValue");
		final String patientDiscoverySortDirection = request
				.getParameter("patientDiscoverySortDirection");

		if (this.validate(request, response, "search")) {
			ReportDataProcessor.setStartAndEndDates(session, startDate, endDate, "patientDiscoveryQuery");
          
            session.setAttribute("patientDiscoveryQuerySSN", ssn);
            session.setAttribute("patientDiscoveryQueryFirstName", firstName);
            session.setAttribute("patientDiscoveryQueryLastName", lastName);            
			session.setAttribute("testPatients", testPatients);
			session.setAttribute("patientDiscoveryMPIResults", mpiMatch);
			session.setAttribute("patientDiscoveryQueryOrganization",
					organization);
                        session.setAttribute("patientDiscoveryQueryOrgName", organizationName);

			// sort
			session.setAttribute("patientDiscoverySortValue",
					patientDiscoverySortValue);
			session.setAttribute("patientDiscoverySortDirection",
					patientDiscoverySortDirection);

			session.setAttribute("paginator", new Paginator(recordsPerPage));
			
			/*if (!NullChecker.isNullOrEmpty(testDataOnly)
					&& testDataOnly.equalsIgnoreCase("ON")) {
				session.setAttribute("testDataOnly", true);
				// TODO communicate to adapter to only use test data
			}else{
				session.setAttribute("testDataOnly", false);
			}*/
			
			this.forward(request, response, "success");
		} else {
			this.forward(request, response, "validate");
		}
	}

	@Override
	protected void unspecified(final HttpServletRequest request,
			final HttpServletResponse response) throws ServletException,
			IOException {
		final HttpSession session = request.getSession(false);

        session.removeAttribute("patientDiscoveryQuerySSN");
        session.removeAttribute("patientDiscoveryQueryLastName");
        session.removeAttribute("patientDiscoveryQueryFirstName");
		session.removeAttribute("patientDiscoveryQueryICN");
		session.removeAttribute("patientDiscoveryQueryStartDate");
		session.removeAttribute("patientDiscoveryQueryEndDate");
		session.removeAttribute("patientDiscoveryQueryOrganization");
		session.removeAttribute("paginator");
		session.removeAttribute("patientDiscoveryResults");
		session.removeAttribute("patientDiscoveryMPIResults");
		session.removeAttribute("testDataOnly");
		session.removeAttribute("testPatients");
		// sort
		session.removeAttribute("patientDiscoverySortValue");
		session.removeAttribute("patientDiscoverySortDirection");

		request.setAttribute("organizations", this.getCmsHelper()
				.getAllOrganizations());

		this.forward(request, response, "show");
	}

}
