/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.web.report;

import gov.va.nvap.common.validation.NullChecker;
import gov.va.nvap.web.app.ResponseDispatcherHttpServlet;
import gov.va.nvap.web.helper.facility.FacilityHelper;
import gov.va.nvap.web.helper.privacy.ConsentManagementHelper;
import gov.va.nvap.web.util.Paginator;
import gov.va.nvap.web.util.date.DateUtil;

import java.io.IOException;
import java.util.Calendar;
import java.util.Date;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 */
public class ReceivedNwHINDocumentSummaryReport extends
		ResponseDispatcherHttpServlet {
	/**
	 * Serial UID.
	 */
	private static final long serialVersionUID = 3721503355079491829L;

	public ConsentManagementHelper getCmsHelper() {
		final ConsentManagementHelper cmsHelper = this.getBean("cmsHelper",
				ConsentManagementHelper.class);
		return cmsHelper;
	}

	/**
	 * Get the facility helper from Spring.
	 */
	public FacilityHelper getFacilityHelper() {
		final FacilityHelper facilityHelper = this.getBean("facilityHelper",
				FacilityHelper.class);
		return facilityHelper;
	}

	public void search(final HttpServletRequest request,
			final HttpServletResponse response) throws ServletException,
			IOException {
		final HttpSession session = request.getSession(false);
		final String startDate = request.getParameter("startDate");
		final String endDate = request.getParameter("endDate");
		final String facility = request.getParameter("facility");
                final String facilityName = request.getParameter("facilityName");
		final String defaultFacility = request.getParameter("defaultFacility");
		final String organization = request.getParameter("organization");
                final String organizationName = request.getParameter("organizationName");
		final String testDataOnly = request.getParameter("testDataOnly");

		if (this.validate(request, response, "search")) {
			ReportDataProcessor.setStartAndEndDates(session, startDate, endDate, "receivedNwHINDocumentSummaryQuery");

			session.setAttribute("receivedNwHINDocumentSummaryQueryFacility",facility);
                        session.setAttribute("receivedNwHINDocumentSummaryQueryFacilityName", facilityName);

			if (!NullChecker.isNullOrEmpty(defaultFacility)
					&& defaultFacility.equalsIgnoreCase("ON")) {
				response.addCookie(this.setFacilityCookie(facility));
			}
			session.setAttribute(
					"receivedNwHINDocumentSummaryQueryOrganizations",
					organization);
                        session.setAttribute("receivedNwHINDocumentSummaryQueryOrgName", organizationName);
			
			if (!NullChecker.isNullOrEmpty(testDataOnly)
					&& testDataOnly.equalsIgnoreCase("ON")) {
				session.setAttribute("testDataOnly", true);
				// TODO communicate to adapter to only use test data
			}else{
				session.setAttribute("testDataOnly", false);
			}
			
			this.forward(request, response, "success");
		} else {
			this.forward(request, response, "validate");
		}
	}

	/**
	 * If the URL starts with redirect: then redirect to a different location
	 * with the same parameters.
	 */
	private Cookie setFacilityCookie(final String setFacility) {

		Cookie vapCookie = null;

		if (setFacility != null) {
			if (setFacility.equals("")) {
				vapCookie = new Cookie("facility", "");
				vapCookie.setMaxAge(0);
			} else {
				vapCookie = new Cookie("facility", setFacility);
				vapCookie.setMaxAge(5 * 365 * 24 * 60 * 60);
			}

			// vapCookie.setPath("/");
			// vapCookie.setDomain("localhost:7001/nhin_vap_web");
		}
		return vapCookie;
	}

	@Override
	protected void unspecified(final HttpServletRequest request,
			final HttpServletResponse response) throws ServletException,
			IOException {
		final HttpSession session = request.getSession(false);
		session.removeAttribute("receivedNwHINDocumentSummaryQueryFacility");
		session.removeAttribute("receivedNwHINDocumentSummaryQueryStartDate");
		session.removeAttribute("receivedNwHINDocumentSummaryQueryEndDate");
		session.removeAttribute("receivedNwHINDocumentSummaryQueryOrganizations");
		session.removeAttribute("paginator");
		session.removeAttribute("receivedNwHINDocumentSummaryResults");
		session.removeAttribute("testDataOnly");

		request.setAttribute("facilities", this.getFacilityHelper()
				.getAllVistAFacilities());
		request.setAttribute("organizations", this.getCmsHelper()
				.getAllowedNonConsumerOnlyOrganizations());
		
		// Get the Default Facility by user id
		/*
		final gov.va.nvap.svc.facility.data.Facility defaultUserFacility = 
			this.getFacilityHelper().getFacilityStationByVHAUserId(request.getRemoteUser());
		if (NullChecker.isNotEmpty(defaultUserFacility)) {
			session.setAttribute("defaultUserFacility",
					defaultUserFacility);
		}*/

		final gov.va.nvap.svc.facility.data.Facility defaultUserFacility = 
			(gov.va.nvap.svc.facility.data.Facility) session.getAttribute("defaultUserFacility");
		
		this.forward(request, response, "show");
	}
}
