	<%--
    Document   : Not Authorized Page
    Author     : 
    Edited     :               
--%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html>
<head>
<%@include file="metaCommon.jspf"%>
<title>Veterans Authorization & Preferences - ${organizationName}
	Authorization</title>
</head>
<body
	onLoad="opt.init(document.multiSelectListForm); setFocus(multiSelectListForm.authenticatingFacility);">
	<table>
		<tr>
			<td>

				<p class="detailText">The Department of Veterans Affairs (VA) is
					only capable of sharing Veteran electronic health information with
					non-VA health care providers participating in ${organizationName}. 
					Some health care providers participate in ${organizationName} by 
					contracting with a health information exchange. By completing the 
					Authorization on VA Form 10-0485, the Veteran is authorizing VA to 
					share his/her health information for treatment purposes with all non-VA 
					health care provider organizations participating in ${organizationName} 
					and partnering with VA.</p>


				<p class="detailText">
					<b>DO NOT</b> initiate an authorize action unless you have a valid
					authorization on file for the patient. NOTE: VA patient information
					is always shared with the DoD. <b>DO NOT</b> authorize DoD
					patients, only announce the Veteran.
				</p></td>
		</tr>
		<tr>
			<td>

				<div class="form-container">
					<fieldset>
						<legend>Authorize</legend>
						<table>
							<tr>
								<td><input type="radio" name="consentGroup"
									value="authorizeAll"
									onClick="formHide('multiSelectAuthorizeForm')" checked>The
									Veteran authorizes the sharing of his/her electronic health
									information with non-VA health care provider organizations
									participating in ${organizationName} and partnering with VA for 
									treatment purposes. The VA will immediately share Veteran 
									electronic health information. <br>
									<br /> <br />
								</td>								
							</tr>
							<tr>
								<td>
									<form name="multiSelectListForm" id="multiSelectListForm"
										action="PatientDetails.do_sec" method="POST"
										enctype="multipart/form-data" onsubmit="return doSubmit(this)">
										<input type="text" name="hiddenText" style="visibility:hidden;display:none;" disabled="disabled" />
										<input type="hidden" name="icn"
											value="${patientDemographics.icn}" /> <input type="hidden"
											name="requestId" value="${requestId}" /> <INPUT
											TYPE="hidden" NAME="newLeft" VALUE="" /> <INPUT
											TYPE="hidden" NAME="newRight" VALUE="" /> <INPUT
											TYPE="hidden" NAME="consentType" VALUE="NwHIN Authorization" />
										<INPUT TYPE="hidden" NAME="purposeOfUse" VALUE="TREATMENT" />
										<INPUT TYPE="hidden" NAME="expirationYears" VALUE="5" />

										<div>
											<label for="authenticatingFacility">Authenticating
												Facility<img alt="Required field" src="res/star-icon_grey_bg.png" /><span
												style="display: none;">Authenticating Facility
													required field</span> </label> <select id="authenticatingFacility"
												name="userFacility">
												<c:forEach var="f" items="${allowedFacilities}">
													<option value="${f.facilityStation}"
														<c:choose>
                                                     		<c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
	                                                         selected
	                                                        </c:when>
                                                     		<c:when test="${cookie.facility.value == f.facilityStation}">
	                                                         selected
	                                                         </c:when>
                                                     	</c:choose>>
														<c:choose>
															<c:when test="${f.facilityName != ''}">
                                                         ${f.facilityName}
                                                       </c:when>
															<c:otherwise>
                                                         ${fn:split(f.facilityDns, '.')[0]}
                                                       </c:otherwise>
														</c:choose>
														(${f.facilityStation})
													</option>
												</c:forEach>
											</select> <br /> <br />
										</div>

										<div>
											<label for="option1">10-0485 Form Validation<img
												alt="Required field" src="res/star-icon_grey_bg.png" /><span
												style="display: none;">Form Validation required field</span>
											</label> <input type="checkbox"
												alt="select Form Validation checkbox if Authorization Form 10-0485 was received and validated. required field"
												onclick="enableAuthorizeAfterValidation('signatureDate', 'option1', 'Authorize');"
												name="option1"
												value="Authorization Form Received and Validated" id="option1">
											Authorization Form Received and Validated &nbsp; <br /> <br />
										</div>
										<div>
											<label for="signatureDate">Patient Signature Date<img
                                                                                                alt="Required field" src="res/star-icon_grey_bg.png" />  <i><span
													style="display: none;"> Patient Signature Date
														required field</span><span style="font-weight: normal;">(mm/dd/yyyy)&nbsp;
														&nbsp;</span> </i> </label><span style="display: none;">Patient
												Signature Date required field</span>
											<date:date id="signatureDate" name="signatureDate" onkeyup="enableAuthorizeAfterValidation('signatureDate', 'option1', 'Authorize');"/>
											&nbsp; <br /><br />
										</div>
										<c:choose>
											<c:when test="${isFormUploadAllowed}">
												<div>
													<label for="file">Upload Consent Form<br /> <i><span
															style="font-weight: normal;">(Max file size:
																${maxFileUploadSize/1000000} megabytes)</span> </i> </label><input
														alt="Browse and Upload Consent Form" name="uploaded"
														type="file" id="file" accept="application/pdf" />&nbsp;
												</div>
											</c:when>
										</c:choose>
                                                                                <div>
                                                                                    <label for="comments">Comments</label>
                                                                                    <span style="display: none;">Patient Comments not a required field</span>
                                                                                    <textarea id="comments" name="comments" style="width: 300px; height: 60px;"></textarea>
                                                                                    <br />
                                                                                </div>
										<br />
										<div align="center">
											<INPUT id="Authorize" class="button" TYPE="SUBMIT"
												disabled="disabled" VALUE="Authorize" name="optIn"
												alt="Authorize">
										</div>
									</form></td>
							</tr>
						</table>
					</fieldset>
				</div></td>
		</tr>
	</table>
</body>
</html>