<%--
    Document   : Expiring Consent Notification
    Created By : Nusrath Mohammed
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
    <head>
        <title>Veterans Authorization & Preferences Expiring Consent Notification</title>

        <%@include file="metaCommon.jspf"%>
    </head>
    <body onload="setFocus(expiringConsentNotificationForm.fileName)">
        <%@include file="header.jspf"%>
        <table border="0" cellpadding="0" cellspacing="0" width="100%"
               summary="table is used for layout purposes" id="main-content-table">
            <tbody>
                <tr>
                    <%@include file="leftMenu.jspf"%>
                    <td id="content-va"><a name="content-area"></a> <!-- START: SITE NAME BAR -->
                        <p class="title-bar">
                            <!-- START: SITE NAME -->
                            Expiring Consent Notification
                            <!-- END: SITE NAME -->
                        </p> <cpp:errors /> <!-- END: SITE NAME BAR -->
                        <table border="0" cellpadding="0" cellspacing="0" width="100%"
                               summary="table is used for layout purposes">
                            <tbody>
                                <tr>
                                    <td id="content-main">
                                        <table width="100%"
                                               summary="This table is used for layout purposes">
                                            <!-- START: PAGE TITLE AREA -->
                                            <!-- END: PAGE TITLE AREA -->
                                            <tr>
                                                <td>
                                                    <!-- START: PAGE CONTENT -->
                                                    <table SUMMARY="This table is for formatting purposes only.">
                                                        <tbody>

                                                            <tr>
                                                                <td>
                                                                    <div class="form-container">
                                                                        <script type="text/javascript" language="javascript">
                                                                            function checkDayRange(form) {
                                                                                var dayRange = document.getElementsByName("maxDaysToExpiration")[0].value;
                                                                                if (isNaN(dayRange) || dayRange < 1 || dayRange > 999) {
                                                                                    window.alert("Day range must be a number from 1 to 999.");
                                                                                    return false;
                                                                                } else {
                                                                                    document.getElementsByName("maxDaysToExpiration")[0].value = parseInt(dayRange);
                                                                                    return doSubmit(form);
                                                                                }
                                                                            }
                                                                        </script> 
                                                                        <form name="expiringConsentNotificationForm"
                                                                              action="ExpiringConsentNotification.do_sec" method="POST"
                                                                              onsubmit="return checkDayRange(this)">
                                                                            <fieldset>
                                                                                <legend>Expiring Consent Notification Details</legend>

                                                                                <div>
                                                                                    <label for="frequency">Frequency<span style="display:none;">"Choose the frequency you want to run from the dropdown list"</span></label>
                                                                                    <select id="frequency" name="frequency">
                                                                                        <c:choose>
                                                                                        <c:when test="${configurationValues.frequency == 'HOURLY'}" >
                                                                                            <option value="HOURLY" selected>Hourly</option>
                                                                                        </c:when>
                                                                                        <c:otherwise>
                                                                                            <option value="HOURLY">Hourly</option>
                                                                                        </c:otherwise>
                                                                                        </c:choose>
                                                                                        <c:choose>
                                                                                            <c:when test="${configurationValues.frequency == 'DAILY'}" >
                                                                                                <option value="DAILY" selected>Daily</option>
                                                                                            </c:when>
                                                                                            <c:otherwise>
                                                                                                <option value="DAILY">Daily</option>
                                                                                            </c:otherwise>
                                                                                        </c:choose>
                                                                                        <c:choose>
                                                                                            <c:when test="${configurationValues.frequency == 'WEEKLY'}" >
                                                                                                <option value="WEEKLY" selected>Weekly</option>
                                                                                            </c:when>
                                                                                            <c:otherwise>
                                                                                                <option value="WEEKLY">Weekly</option>
                                                                                            </c:otherwise>
                                                                                        </c:choose>
                                                                                        <c:choose>
                                                                                            <c:when test="${configurationValues.frequency == 'MONTHLY'}" >
                                                                                                <option value="MONTHLY" selected>Monthly</option>
                                                                                            </c:when>
                                                                                            <c:otherwise>
                                                                                                <option value="MONTHLY">Monthly</option>
                                                                                            </c:otherwise>
                                                                                        </c:choose>
                                                                                        <option value="-1">ALL</option>
                                                                                    </select>
                                                                                </div>
                                                                                <div>
                                                                                    <label for="maxDaysToExpiration">Days Until Expiration<span style="display:none;">"Choose the number of days you want to select from the dropdown list"</span></label>
                                                                                    <input alt="Enter range in days." 
                                                                                        id="maxDaysToExpiration" name="maxDaysToExpiration" type="text" 
                                                                                        maxlength="3" value="${configurationValues.window}" size="3"/>
                                                                                </div>
                                                                                <div>
                                                                                    <label for="distributionList">Distribution List<br />
                                                                                        <span style="font-weight: normal;">(one email address per line)</span></label>
                                                                                    <textarea id="distributionList" name="distributionList" rows="8" cols="55" >${configurationValues.emailAddresses}</textarea>
                                                                                </div>
                                                                                <div class="buttonrow">
                                                                                    <input name="save" id="save" alt="Save" class="button" type="submit" 
                                                                                           value="Save" />
                                                                                </div>
                                                                            </fieldset>
                                                                        </form>
                                                                    </div>
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table> <!-- THE BODY CONTENT END -->
                                                </td>
                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                            </tbody>
                        </table> <!-- START: PAGE FOOTER --> <%@include file="footer.jspf"%>
                        <!-- END: PAGE FOOTER --> <!-- END: PAGE CONTENT -->
                    </td>
                </tr>
            </tbody>
        </table>
    </body>
</html>
