<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
<head>
<title>Veterans Authorization & Preferences Expiring Consent Report</title>
<%@include file="metaCommon.jspf"%>
</head>
<body onload="setFocus(expiringConsentReportForm.dayRange)">
	<%@include file="header.jspf"%>
	<table border="0" cellpadding="0" cellspacing="0" width="100%"
		summary="table is used for layout purposes" id="main-content-table">
		<tbody>
			<tr>
				<%@include file="leftMenu.jspf"%>
				<td id="content-va"><a name="content-area"></a> <!-- START: SITE NAME BAR -->
					<p class="title-bar">
						<!-- START: SITE NAME -->
						Expiring Consent Report
						<!-- END: SITE NAME -->
					</p> <cpp:errors /> <!-- END: SITE NAME BAR -->
					<table border="0" cellpadding="0" cellspacing="0" width="100%"
						summary="table is used for layout purposes">
						<tbody>
							<tr>
								<td id="content-main">
									<table width="100%"
										summary="This table is used for layout purposes">
										<!-- START: PAGE TITLE AREA -->
										<!-- END: PAGE TITLE AREA -->
										<tr>
											<td>
												<!-- START: PAGE CONTENT -->
												<table SUMMARY="This table is for formatting purposes only.">
													<tbody>
														<tr>
															<td id="content-page-content-title" width="100%"><font
																id="content-page-title-font">Fill in the fields
																	below to narrow your search.</font></td>
														</tr>
														<tr>
															<td>
																<div class="form-container">
                                                                    <script type="text/javascript" language="javascript">
                                                                        function checkDayRange(form) {
                                                                            // Does not check for invalid month or day number
                                                                            var startDate = document.getElementsByName("startDate")[0].value;
                                                                            if (!/^\d{2}\/\d{2}\/\d{4}/.test(startDate)) {
                                                                                window.alert("Start Date must be in format: mm/dd/yyyy");
                                                                                return false;
                                                                            }
                                                                            
                                                                            var endDate = document.getElementsByName("endDate")[0].value;
                                                                            if (!/^\d{2}\/\d{2}\/\d{4}/.test(endDate)) {
                                                                                window.alert("End Date must be in format: mm/dd/yyyy");
                                                                                return false;
                                                                            } else {
                                                                                return doSubmit(form);
                                                                            }
                                                                        }
                                                                    </script>                                     
																	<form name="expiringConsentReportForm"
																		action="ExpiringConsentReport.do_sec" method="POST"
																		onsubmit="return checkDayRange(this)">
																		<fieldset>
																			<legend>Search Details</legend>
                                                                            <div>
                                                                                <label for="startDate">Start Date <i><span style="font-weight:normal;">(mm/dd/yyyy)</span></i></label>
                                                                                <input alt="Enter the start date for the expiring consent report."
                                                                                       id="startDate" name="startDate" type="text"
                                                                                       maxlength="10" value="${startDateString}" size="7">
                                                                            </div>
                                                                            <div>
                                                                                <label for="endDate">End Date <i><span style="font-weight:normal;">(mm/dd/yyyy)</span></i></label>
                                                                                <input alt="Enter the end date for the expiring consent report."
                                                                                       id="endDate" name="endDate" type="text"
                                                                                       maxlength="10" value="${endDateString}" size="7">
                                                                            </div>
                                                                            <div>
                                                                                <label for="facility">VA Facility<span style="display:none;">"Query based on VA Facility from the dropdown list"</span></label>
                                                                                <select id="facility" name="facility">
                                                                                    <option value="">ALL</option>
                                                                                    <c:forEach var="f" items="${facilities}">
                                                                                        <option value="${f.facilityName}"
                                                                                            <c:choose>
                                                                                                <c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
                                                                                                    selected
                                                                                                </c:when>
                                                                                            </c:choose>>
                                                                                            <c:choose>
                                                                                                <c:when test="${f.facilityName != ''}">
                                                                                                    ${f.facilityName}
                                                                                                </c:when>
                                                                                                <c:otherwise>
                                                                                                    ${fn:split(f.facilityDns, '.')[0]}
                                                                                                </c:otherwise>
                                                                                            </c:choose>
                                                                                            (${f.facilityStation})
                                                                                        </option>
                                                                                    </c:forEach>
                                                                                </select>
                                                                            </div>
                                                                            <div>
                                                                                <label for="consentTypeName">Consent Type<span style="display:none;">"Query based on consent type from the dropdown list"</span></label>
                                                                                <select id="consentTypeName" name="consentTypeName">
                                                                                    <option value="" selected>ALL Authorizations</option>
                                                                                    <option value="NwHIN Authorization">${organizationName} Authorizations</option>
                                                                                    <option value="SSA Authorization">SSA Authorizations</option>
                                                                                </select>
                                                                            </div>
                                                                            <div>
                                                                                <label for="enteredBy">Entered By<span style="display:none;">"Query based on whom entered information from the dropdown list"</span></label>
                                                                                <select id="enteredBy" name="enteredBy">
                                                                                    <option value="" selected>ALL</option>
                                                                                    <option value="eBenefits">eBenefits</option>
                                                                                    <option value="employee">Employee</option>
                                                                                </select>
                                                                            </div>
																			<div>
																				<label alt="Choose the number of records you want to view from the dropdown list" for="recordsPerPage">Records Per Page</label>
																				<select id="recordsPerPage" name="recordsPerPage">
																					<option value="10">10</option>
																					<option value="25" selected>25</option>
																					<option value="50">50</option>
																					<option value="100">100</option>
                                                                                    <option value="-1">ALL</option>
																				</select>
																			</div>
                                                                            <div>
                                                                                <label for="testPatients">Include Test Patients</label>
                                                                                <input type="checkbox" name="testPatients" id="testPatients" value="testPatients" alt="Check to Include the Test Patients"/>
                                                                            </div>
                                                                        </fieldset>
																		<div class="buttonrow">
																			<input name="search" alt="Search" class="button" type="submit" value="Search" 
                                                                                <c:if test="${testPatients}"> checked="true"</c:if>
                                                                            />
																		</div>
																	</form>
																</div>
															</td>
														</tr>
													</tbody>
												</table> <!-- THE BODY CONTENT END -->
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</tbody>
					</table> <!-- START: PAGE FOOTER --> <%@include file="footer.jspf"%>
					<!-- END: PAGE FOOTER --> <!-- END: PAGE CONTENT -->
				</td>
			</tr>
		</tbody>
	</table>
</body>
</html>
