<%--
    Document   : Not Authorized Page
    Author     : Asha Amritraj
--%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
<head>
<%@include file="metaCommon.jspf"%>
<title>Veterans Authorization & Preferences - Restrict ${organizationName}
	Organization</title>
<SCRIPT LANGUAGE="JavaScript">
	opt.init(document.multiSelectListForm);
</SCRIPT>
</head>
<body onLoad="setFocus(multiSelectListForm.authenticatingFacility);">
	<table>
		<tr>
			<td>

				<p class="detailText">The Veteran has a right to request the
					Department of Veterans Affairs (VA) to restrict or limit the
					sharing of his/her electronic health information through ${organizationName} 
					by designating which non-VA healthcare provider organizations 
					he/she does NOT wish to receive his/her information. A restriction 
					request may be filed even if the Veteran does not have an authorization 
					on file permitting the disclosure of his/her health information to 
					non-VA healthcare provider organizations. Note that until an 
					authorization is on file, the restriction request will remain in an 
					<b>inactive</b> status. Any restriction request submitted will apply 
					ONLY to the sharing of electronic health information through 
					<b>${organizationName}</b>.</p>

				<p class="detailText">Indicate which non-VA health care provider 
					organization participating in ${organizationName} the Veteran does NOT 
					wish to receive their electronic health information. By completing the 
					Restriction on VA Form 10-0525a, the Veteran is restricting the VA 
					from sharing his/her health information for treatment purposes 
					with the non-VA health care provider organizations participating 
					in the ${organizationName} and partnering with VA.</p>

				<p class="detailText">The VA will not share the Veteran health 
				information with the selected non-VA health care provider 
				organizations through ${organizationName} even if the Veteran later signs 
				an authorization.</p>
			</td>
		</tr>
		<tr>
			<td>

				<div class="form-container">
					<fieldset>
						<legend>Restrict</legend>
						<table>
							<tr>
								<td><input checked
									alt="Choose the radio button to select Patient Authorizes sharing of health
								 records with ${organizationName} providers and organizations with the following exclusions:"
									type="radio" name="consentGroup" value="authorizeExclusion"
									onClick="formShow('multiSelectAuthorizeForm')">Veteran
									Restricts sharing of health records with ${organizationName}
									providers and organizations with the
									following exclusions:<br /> <br />
									</td>
							</tr>
							<tr>
								<td>
									<form name="multiSelectListForm" id="multiSelectListForm"
										action="PatientDetails.do_sec" method="POST"
										enctype="multipart/form-data" onsubmit="return doSubmit(this)">

										<input type="hidden" name="icn"
											value="${patientDemographics.icn}" /> <input type="hidden"
											name="requestId" value="${requestId}" /> <INPUT
											TYPE="hidden" NAME="newLeft" VALUE="" /> <INPUT
											TYPE="hidden" NAME="newRight" VALUE="" /> <INPUT
											TYPE="hidden" NAME="consentType"
											VALUE="NwHIN Organization Restriction Modification" /> <INPUT
											TYPE="hidden" NAME="purposeOfUse" VALUE="TREATMENT" />

										<div id="multiSelectAuthorizeForm">
											<table bgcolor="#eff2ff">
												<tr>
													<td colspan="3">There must be at least one non-VA health care 
														provider organization -- other than Department of Defense 
														(DoD) --- in the "All Providers and Organizations <b>(unrestricted)</b>" 
														selection box AND at least one non-VA health care provider 
														organization in the "${organizationName} Providers and Organizations 
														who will NOT have access to the records <b>(restricted)</b>" box. <br /> <br />
														
														<p class="detailText">* NOTE: You cannot restrict DoD, VA patient
															information is always shared with the DoD.<br /> <br /></p>
													</td>
												</tr>

												<TR>
													<TD><label> <span style="display: none;">"This
																table has two list boxes:All Providers and Organizations
																list box and ${organizationName} Providers and Organizations 
																who will NOT have access to the patient records list box. 
																Choose and move the Organizations from the first list box to
																the next. </span> </label> <label for="list1" style="display: none;">
															All Providers and Organizations (unrestricted)</label><br /> <b>All
															Providers and Organizations (unrestricted)</b></TD>
													<TD>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
													<TD><b>${organizationName} Providers and Organizations who will
															NOT have access to the records (restricted)</b></TD>
												</TR>
												<TR>
													<TD><SELECT style="width: 310px;" class="listSelect"
														NAME="list1" id="list1" multiple="true" size="10"
														onDblClick="opt.transferRight();enableRestrictAfterValidation('signatureDate', 'option1', 'list1', 'list2', 'Authorize');">

															<c:if test="${!empty authorizedOrganizations}">
																<c:forEach var="r" items="${authorizedOrganizations}"
																	varStatus="i">
																	<c:choose>
																		<c:when test="${r.orgNumber eq  '200DOD'}">
																			<option value="${r.orgNumber}">* ${r.orgName}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
																		</c:when>
																		<c:otherwise>
																			<option value="${r.orgNumber}">${r.orgName}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
																		</c:otherwise>
																	</c:choose>
																</c:forEach>
															</c:if>
													</SELECT>
													</TD>
													<TD VALIGN="MIDDLE" ALIGN="LEFT"><INPUT
														style="width: 125px; height: 30px;" TYPE="button"
														alt="Move All"
														title="Move all the Organizations to the right box"
														class="midButton" NAME="right" VALUE="Move All &gt;&gt;"
														ONCLICK="opt.transferAllRight();enableRestrictAfterValidation('signatureDate', 'option1', 'list1', 'list2', 'Authorize');"><BR> <INPUT
														TYPE="button" alt="Move Selected to right "
														title="Move the Selected Organizations to the right box"
														class="midButton" style="width: 125px; height: 30px;"
														NAME="right" VALUE="Move Selected &gt;"
														ONCLICK="opt.transferRight();enableRestrictAfterValidation('signatureDate', 'option1', 'list1', 'list2', 'Authorize');"> <BR> <BR>
														<INPUT TYPE="button" alt="Move selected to left"
														title="Move the selected Organizations to the left box"
														class="midButtonLeft" style="width: 125px; height: 30px;"
														NAME="left" VALUE="&lt; Move Selected"
														ONCLICK="opt.transferLeft();enableRestrictAfterValidation('signatureDate', 'option1', 'list1', 'list2', 'Authorize');"> <br /> <INPUT
														TYPE="button" alt="Clear" title="Clear all selections"
														class="midButton" NAME="left"
														style="width: 125px; height: 30px;" VALUE="Clear"
														ONCLICK="opt.transferAllLeft();disableObject('Authorize');"></TD>

													<TD><label for="list2" style="display: none;">${organizationName}
															Providers and Organizations who will NOT have access to
															the records</label> <SELECT NAME="list2" class="listSelect"
														multiple="true" size="10" id="list2"
														onDblClick="opt.transferLeft();enableRestrictAfterValidation('signatureDate', 'option1', 'list1', 'list2', 'Authorize');" style="width: 310px;">
															<c:if test="${!empty excludedOrganizations}">
																<c:forEach var="r" items="${excludedOrganizations}"
																	varStatus="i">
																	<option value="${r.orgNumber}">${r.orgName}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
																</c:forEach>
															</c:if>
													</SELECT>
													</TD>
												</TR>
											</table>
											<br /> <br />
										</div>
										<div>
											<label>Authenticating
												Facility<img alt="Required field" src="res/star-icon_grey_bg.png" /><span
												style="display: none;">Authenticating Facility
													required field</span> </label> <select id="authenticatingFacility"
												name="userFacility">
												<c:forEach var="f" items="${allowedFacilities}">
													<option value="${f.facilityStation}"
														<c:choose>
                                                     		<c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
	                                                         selected
	                                                        </c:when>
                                                     		<c:when test="${cookie.facility.value == f.facilityStation}">
	                                                         selected
	                                                         </c:when>
                                                     	</c:choose>>
														<c:choose>
															<c:when test="${f.facilityName != ''}">
                                                         ${f.facilityName}
                                                       </c:when>
															<c:otherwise>
                                                         ${fn:split(f.facilityDns, '.')[0]}
                                                       </c:otherwise>
														</c:choose>
														(${f.facilityStation})
													</option>
												</c:forEach>
											</select> <br /> <br />
										</div>

										<div>
											<label>10-0525a Form Validation<img
												alt="Required field" src="res/star-icon_grey_bg.png" /><span
												style="display: none;">Form Validation required field</span>
											</label> <input type="checkbox"
												alt="select Form Validation checkbox if Restriction Form 10-0525a was received and validated. required field"
												onclick="enableRestrictAfterValidation('signatureDate', 'option1', 'list1', 'list2', 'Authorize');"
												name="option1" id="option1" value="Restriction Form Received and Validated">
											Restriction Form Received and Validated &nbsp; <br /> <br />
										</div>
										<div>
											<label>Patient Signature Date<img
												alt="Required field" src="res/star-icon_grey_bg.png" /> <i><span
													style="display: none;"> Patient Signature Date
														required field</span><span style="font-weight: normal;">(mm/dd/yyyy)&nbsp;
														&nbsp;</span> </i> </label> <span style="display: none;">Patient
												Signature Date required field</span>
											<date:date id="signatureDate" name="signatureDate" onkeyup="enableRestrictAfterValidation('signatureDate', 'option1', 'list1', 'list2', 'Authorize');"/>
											&nbsp; <br />
										</div>
										<c:choose>
											<c:when test="${isFormUploadAllowed}">
												<div>
													<label for="file">Upload Consent Form<br /> <i><span
															style="font-weight: normal;">(Max file size:
																${maxFileUploadSize/1000000} megabytes)</span> </i> </label><input
														alt="Browse and Upload Consent Form" name="uploaded"
														type="file" id="file" accept="application/pdf" />&nbsp;
												</div>
											</c:when>
										</c:choose>
                                                                                <div>
                                                                                    <label for="comments">Comments</label>
                                                                                    <span style="display: none;">Patient Comments not a required field</span>
                                                                                    <textarea id="comments" name="comments" style="width: 300px; height: 60px;"></textarea>
                                                                                    <br />
                                                                                </div>
										<br />
										<div align="center">
											<INPUT id="Authorize" class="button" TYPE="SUBMIT"
												disabled="disabled" VALUE="Restrict" name="optIn"
												alt="Authorize">
										</div>
									</form>
								</td>
							</tr>
						</table>
					</fieldset>
				</div>
			</td>
		</tr>
	</table>
</body>
</html>