<%--
    Document   : Opt-in/Opt-out Report
    Created By : 
    Modified By:               
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
    <head>
        <script type="text/javascript" src="js/errors.js"></script>
        <%@include file="metaCommon.jspf" %>
        <title>Veterans Authorization & Preferences Consent Directive Report</title>

     	<script language="JavaScript">
                        var mapVisn = new Array();
                        
                        function onPageLoad() {
                            // make a map of all of the VISNs with a list of each
                            // facility in that VISN
                            
                            // first add a list of "ALL" facilities
                            mapVisn["ALL"] = new Array();
                            <c:forEach var="f" items="${facilities}" varStatus="i">
                                // construct the facility name that will go in the facilities list box
                                <c:set var="facilityDisplayName" scope="page" value=""/>
                                <c:choose>
                                    <c:when test="${f.facilityName != ''}">
                                        <c:set var="facilityDisplayName" scope="page" value="${f.facilityName} (${f.facilityStation})"/>
                                    </c:when>
                                    <c:otherwise>
                                        <c:set var="facilityDisplayName" scope="page" value="${fn:split(f.facilityDns, '.')[0]} (${f.facilityStation})"/>
                                    </c:otherwise>
                                </c:choose>

                                var valueDisplay = new Array();
                                valueDisplay.push("${f.facilityName}");
                                valueDisplay.push("${facilityDisplayName}")
                                mapVisn["ALL"].push(valueDisplay);

                            </c:forEach>
                            
                            <c:forEach var="v" items="${visns}">
                                // add this VISN to the map
                                mapVisn["${v.visnName}"] = new Array();
                                
                                // add all of the facilities that are in this VISN
                                <c:forEach var="f" items="${facilities}" varStatus="i">
                                    <c:if test="${f.visnId == v.id}">
                                        // this facility belongs to this VISN
                                        
                                        // construct the facility name that will go in the facilities list box
                                        <c:set var="facilityDisplayName" scope="page" value=""/>
                                        <c:choose>
                                            <c:when test="${f.facilityName != ''}">
                                                <c:set var="facilityDisplayName" scope="page" value="${f.facilityName} (${f.facilityStation})"/>
                                            </c:when>
                                            <c:otherwise>
                                                <c:set var="facilityDisplayName" scope="page" value="${fn:split(f.facilityDns, '.')[0]} (${f.facilityStation})"/>
                                            </c:otherwise>
                                        </c:choose>
                                    
                                        var valueDisplay = new Array();
                                        valueDisplay.push("${f.facilityName}");
                                        valueDisplay.push("${facilityDisplayName}")
                                        mapVisn["${v.visnName}"].push(valueDisplay);
                                    </c:if>
                                </c:forEach>
                            </c:forEach>
                                
                            setFocus(optInOptOutReportForm.ssn);
                        }
                        
			function formShow(id) {
					document.getElementById(id).style.display = "block";
			}
			function formHide(id) {
				document.getElementById(id).style.display = "none";
			}
			function onOptoutReasonChange(selectedItem) {
				 if(selectedItem.value == 'OPT-OUT')
				 {
					 formShow ('optOutReasonDiv');
				 }
				 else {
					 formHide ('optOutReasonDiv');
				 }
			}
			function onConsentTypeChange(selectedItem) {
				 if(selectedItem.value.toLowerCase().indexOf('revocations') != -1)
				 {
					 formShow ('inactivationReasonDiv');
				 }
				 else {
					 formHide ('inactivationReasonDiv');
				 }
			}
                        
                        function onVisnChange(select) {
                            // what is the new selected VISN?
                            var newVisn = select.value;
                            if ((newVisn == null) || (newVisn == "")) {
                                newVisn = "ALL";
                            }
                            
                            // what is the currently selected facility
                            var facilitiesSelect = document.getElementById("facility");
                            var lastSelectedFacilityValue = facilitiesSelect.value;
                            
                            // re-populate the Facilities list box with the facilities
                            // that are in this new VISN that was selected
                            if (mapVisn[newVisn] != null) {
                                
                                // first remove all items currently in the Facilities list box
                                while(facilitiesSelect.options.length > 0) {                
                                    facilitiesSelect.remove(0);
                                }
                                
                                // now add the appropriate facilities to the list box
                                // (always add "ALL" at the top)
                                var newFacilityItem = document.createElement("option");
                                newFacilityItem.value = "";
                                newFacilityItem.textContent = "ALL";
                                facilitiesSelect.appendChild(newFacilityItem);
                                
                                var facilities = mapVisn[newVisn];
                                for (var i = 0; i < facilities.length; i++) {
                                    newFacilityItem = document.createElement("option");
                                    
                                    var facility = facilities[i];
                                    var value = facility[0];
                                    var display = facility[1];
                                    
                                    newFacilityItem.value = value;
                                    newFacilityItem.textContent = display;
                                    
                                    // was the previously selected facility in this list?
                                    if (value == lastSelectedFacilityValue) {
                                        newFacilityItem.selected = true;
                                    }
                                    
                                    facilitiesSelect.appendChild(newFacilityItem);
                                }
                            }
                            
                            return true;
                        }
		</script>
    </head>
<body onload="onPageLoad()">
<%@include file="header.jspf" %>
<table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes" id="main-content-table">
	<tbody>
    	<tr>
			<%@include file="leftMenu.jspf" %>
            <td id="content-va">
                <a name="content-area"></a>
                <!-- START: SITE NAME BAR -->
                <p class="title-bar"><!-- START: SITE NAME -->Consent Directive Report<!-- END: SITE NAME --></p>
                <cpp:errors />
                <!-- END: SITE NAME BAR -->
                <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes">
                    <tbody>
                        <tr>
                            <td id="content-main">
                            	<table width="100%" summary="This table is used for layout purposes">
                                  <!-- START: PAGE TITLE AREA -->
                                  <!-- END: PAGE TITLE AREA -->
    	                          <tr>
	    		                      <td>
                			            <!-- START: PAGE CONTENT -->
                                        <table SUMMARY="This table is for formatting purposes only.">
                                            <tbody>
												<tr>
					                              <td id="content-page-content-title" width="100%"><font id="content-page-title-font">Fill in the fields below to narrow your search.
 All dates will be included if Start Date and End Date are left blank.</font></td>
                				                </tr>
                              					<tr>
												    <td>
                                                        <div class="form-container">
                                                            <form name="optInOptOutReportForm" action="OptInOptOutReport.do_sec" method="POST" onsubmit="return doSubmit(this)">
                                                                <fieldset>
                                                                    <input type="hidden" id="consentTypeName" name="consentTypeName">
                                                                    <input type="hidden" id="inactivationReason" name="inactivationReason">
                                                                	<legend>Search Details</legend>
                                                                    	<div>
                                                                            <label for="ssn">SSN <i><span style="font-weight:normal;">(#########)</span></i></label>
                                                                            <input alt="Enter SSN. Enter numbers only no hyphens" id="ssn" name="ssn" type="text" maxlength="9" size="9" /> <i><span style="font-weight:normal;"> (Enter numbers only, no hyphens.)</span></i> &nbsp;
	                                                                     </div>
                                                                    	<div>
                                                                            <label for="lastName">Last Name</label>
                                                                            <input alt="Enter Last Name" id="lastName" name="lastName" type="text" maxlength="255" size="30" />
                                                                    	</div>
                                                                    	<div>
                                                                            <label for="firstName">First Name</label>
                                                                            <input alt="Enter First Name" id="firstName" name="firstName" type="text" maxlength="255" size="30" />
                                                                    	</div>
                                                                    	<div>
                                                                            <label for="startDate">Start Date <i><span style="font-weight:normal;">(mm/dd/yyyy)</span></i></label>
                                                                            <date:date id="startDate" name="startDate" />&nbsp;
                                                                    	</div>
                                                                    	<div>
                                                                            <label for="endDate">End Date <i><span style="font-weight:normal;">(mm/dd/yyyy)</span></i></label>
                                                                            <date:date id="endDate" name="endDate" />&nbsp;
                                                                    	</div>
                                                                        <div>
                                                                            <label for="visn">VA VISN<span style="display:none;">"Query based on VA VISN from the dropdown list"</span></label>
                                                                            <select id="visn" name="visn" onchange="onVisnChange(this)">
                                                                                <option value="">ALL</option>
                                                                                <c:forEach var="v" items="${visns}">
                                                                                    <option value="${v.visnName}">
                                                                                        ${v.visnName}
                                                                                    </option>
                                                                                </c:forEach>
                                                                            </select>
                                                                        </div>
                                                                        <div>
                                                                            <label for="facility">VA Facility<span style="display:none;">"Query based on VA Facility from the dropdown list"</span></label>
                                                                            <select id="facility" name="facility">
                                                                                <option value="">ALL</option>
                                                                                <c:forEach var="f" items="${facilities}">
                                                                                    <option value="${f.facilityName}"
                                                                                    <c:choose>
                                                     											<c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
	                                                         										selected
	                                                        									</c:when>
                                                     										</c:choose>>
																								
                                                                                    <c:choose>
                                                                                      <c:when test="${f.facilityName != ''}">
                                                                                        ${f.facilityName}
                                                                                      </c:when>
                                                                                      <c:otherwise>
                                                                                        ${fn:split(f.facilityDns, '.')[0]}
                                                                                      </c:otherwise>
                                                                                    </c:choose>
                                                                                    (${f.facilityStation})
                                                                                    </option>
                                                                                    </c:forEach>
                                                                                </select>
                                                                        </div>
                                                                       <div>
                                                                            <label for="consentType">Consent Type <span style="display:none;">"Query based on consent type from the dropdown list"</span></label>
                                                                            <select id="consentType" name="consentType" onChange="onConsentTypeChange(this.options[this.selectedIndex])
                                                                                    document.getElementById('consentTypeName').value = this.selectedOptions[0].text;">
                                                                                <option value="" selected>ALL</option>
                                                                                <option value="allAuthorizations">ALL Authorizations</option>
                                                                                <option value="allRevocations" >ALL Revocations</option>
                                                                                <option value="NwHINAuthorizations" >${organizationName} Authorizations</option>
                                                                                <option value="SSAAuthorizations" >SSA Authorizations</option>
                                                                                <option value="NwHINRevocations" >${organizationName} Revocations</option>
                                                                                <option value="SSARevocations" >SSA Revocations</option>
                                                                                <option value="NwHINRestrictions" >${organizationName} Restrictions</option>
                                                                                <option value="NwHINRestrictionRevocations" >${organizationName} Restriction Revocations</option>
                                                                            </select>
                                                                        </div>
                                                                        <div id="inactivationReasonDiv" style="display: none;">
                                                                            <label for="inactivationReason">Inactivation Reason<span style="display:none;">"Query based on Authorization or Revocation from the dropdown list"</span></label>
                                                                            <select id="inactivationReason" name="inactivationReason" 
                                                                                    onchange="document.getElementById('inactivationReason').value = this.selectedOptions[0].text;">
                                                                                <option value="" selected>ALL</option>
                                                                                <option value="New Authorization">New Authorization</option>
                                                                                <option value="Patient Deceased" >Patient Deceased</option>
                                                                                <option value="Entered in Error" >Entered in Error</option>
                                                                                <option value="Authorization Expired" >Authorization Expired</option>
                                                                                <option value="Revoked" >Revoked</option>
                                                                            </select>
                                                                        </div>
                                                                        <div>
                                                                            <label for="enteredBy">Entered By<span style="display:none;">"Query based on whom entered information from the dropdown list"</span></label>
                                                                            <select id="enteredBy" name="enteredBy">
                                                                                <option value="" selected>ALL</option>
                                                                                <option value="eBenefits">eBenefits</option>
                                                                                <option value="employee" >Employee</option>
                                                                            </select>
                                                                        </div>
                                                                        
                                                                    	<div>
                                                                            <label for="recordsPerPage">Records Per Page<span style="display:none;">"Choose the number of records you want to view from the dropdown list"</span></label>
                                                                            <select id="recordsPerPage" name="recordsPerPage">
                                                                                <option value="10">10</option>
                                                                                <option value="25" selected>25</option>
                                                                                <option value="50">50</option>
                                                                                <option value="100">100</option>
                                                                                <option value="-1">ALL</option>
                                                                            </select>
                                                                    	</div>
                                                                        <div>
                                                                                <label for="testPatients">Include Test Patients</label>
                                                                                <input type="checkbox" name="testPatients" id="testPatients" value="testPatients" alt="Check to Include the Test Patients"/>
                                                                            </div>
                                                                        </fieldset>
                                                                <div class="buttonrow">
                                                                    <input name="search" alt="Search" class="button" type="submit" value="Search" />
                                                                </div>
                                                            </form>
                                                        </div>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                        <!-- THE BODY CONTENT END -->
                                       </td>
                                 	</tr>
								</table>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <!-- START: PAGE FOOTER -->
                <%@include file="footer.jspf" %>
                <!-- END: PAGE FOOTER -->
                <!-- END: PAGE CONTENT -->
            </td>
        </tr>
    </tbody>
</table>
</body>
</html>