﻿<%--
    Document   : Opt-in/Opt-out Report
    Created By : 
    Modified By: 
--%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/paginator" prefix="pg"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
        <head>
        <title>Veterans Authorization & Preferences Consent Directive Report Results</title>
        <%@include file="metaCommon.jspf" %>
        
<script>
function onSubmit(){
	var totalRows = document.getElementById('totalRows').value;
	var consentDirectiveLettersMaxTime = document.getElementById('consentDirectiveLettersMaxTime').value;
	var consentDirectivePerLetterTime = document.getElementById('consentDirectivePerLetterTime').value;
	
	var totalTimeToDownload = totalRows*consentDirectivePerLetterTime;
	var message = 'It will take a minimum of ' + totalTimeToDownload + ' seconds to download the Patient Notification Letters.' + "\n";
	
	if ( totalTimeToDownload >= consentDirectiveLettersMaxTime){
		message += 'This is longer than system timeout of ' + consentDirectiveLettersMaxTime + ' seconds. Please refine search criteria and try again.';
		alert(message);
		return false;
	}
	
	message += 'Do you wish to continue?';	
	if (confirm(message)) {
	    return true;
	} else {
		
		return false;
	}
}
</script>
        </head>
<body>
<%@include file="header.jspf" %>
<%@include file="patientLinkForm.jspf"%>
<table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes" id="main-content-table">
	<tbody>
    	<tr>
			<%@include file="leftMenu.jspf" %>
            <td id="content-va">
                <a name="content-area"></a>
                <!-- START: SITE NAME BAR -->
                <p class="title-bar"><!-- START: SITE NAME -->Consent Directive Report<!-- END: SITE NAME --></p>
                <cpp:errors />
                <!-- END: SITE NAME BAR -->
                <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes">
                    <tbody>
                        <tr>
                            <td id="content-main">
                            	<table width="100%" summary="This table is used for layout purposes">
                                  <!-- START: PAGE TITLE AREA -->
                                  <!-- END: PAGE TITLE AREA -->
    	                          <tr>
	    		                      <td>
                			            <!-- START: PAGE CONTENT -->
                                        <table SUMMARY="This table is for formatting purposes only.">
                                            <tbody>
                                                <tr>
                                                    <td>
                                                        <table id="ver-minimalist">
                                                            <tbody>
                                                                <tr>
                                                                    <div class="buttonrow">
                                                                        <c:choose>
                                                                            <c:when test="${!empty optInOptOutResults}">
                                                                                <form>
                                                                                <input type="hidden" name="totalRows" id="totalRows" value="${totalRows}">
                                                                                <input type="hidden" name="consentDirectiveLettersMaxTime" id="consentDirectiveLettersMaxTime" value="${consentDirectiveLettersMaxTime}">
                                                                                <input type="hidden" name="consentDirectivePerLetterTime" id="consentDirectivePerLetterTime" value="${consentDirectivePerLetterTime}">
                                                                                <!--input name="download" alt="Download Patient Notification Letters" class="button" type="submit" onclick="return onSubmit()"
                                                                                    value="Download Patient Notification Letters" /--> 
                                                                                </form>
                                                                            </c:when>
                                                                        </c:choose>
                                                                        <a href="OptInOptOutReportResults.do_sec?exportToExcel=true">
                                                                            <input name="exportToExcel" alt="Export to Excel" class="button" type="submit" value="Export to Excel" /></a>
                                                                    </div>
                                                                </tr>
                                                                <tr>
                                                                    <td>Patient ID (ICN)</td>
                                                                    <td><c:choose>
                                                                            <c:when test="${!empty optInOptOutQueryICN}">
                                                                                    ${optInOptOutQueryICN}
                                                                                </c:when>
                                                                            <c:otherwise>
                                                                                    ALL
                                                                                </c:otherwise>
                                                                        </c:choose>
                                                                    </td>
                                                                    <td>Start Date</td>
                                                                    <td><c:choose>
                                                                            <c:when test="${!empty optInOptOutQueryStartDate}">
                                                                                <fmt:formatDate pattern="MM/dd/yyyy"
                                                                                    value="${optInOptOutQueryStartDate}" />
                                                                            </c:when>
                                                                            <c:otherwise>
                                                                                    N/A
                                                                                </c:otherwise>
                                                                        </c:choose>
                                                                    </td>
                                                                    <td>End Date</td>
                                                                    <td><c:choose>
                                                                            <c:when test="${!empty optInOptOutQueryEndDate}">
                                                                                <fmt:formatDate pattern="MM/dd/yyyy"
                                                                                    value="${optInOptOutQueryEndDate}" />
                                                                            </c:when>
                                                                            <c:otherwise>
                                                                                    N/A
                                                                                </c:otherwise>
                                                                        </c:choose>
                                                                    </td>
                                                            </tbody>
                                                        </table>
                                                        <c:choose>
                                                            <c:when test="${!empty optInOptOutResults}">
                                                                <pg:paginator paginator="${paginator}"
                                                                    uri="OptInOptOutReportResults.do_sec"
                                                                    results="${optInOptOutResults}" />
                                                               <table width="100%">
                                                                    <thead>
                                                                        <tr id="hor-minimalist-c">
                                                                            <th scope="col">SSN</th>
                                                                            <th scope="col">Patient Last Name</th>
                                                                            <th scope="col">Patient First Name</th>
                                                                            <th scope="col">Time of Event</th>
                                                                            <th scope="col">Patient Signature/</br>Patient Deceased Date</th>
                                                                            <th scope="col">Purpose of Use</th>
                                                                            <th scope="col">Consent Type</th>
                                                                            <th scope="col">Inactivation Reason</th>
                                                                            <th scope="col">Entered By</th>
                                                                            <th scope="col">VA Facility</th>
                                                                            <th scope="col">VISN</th>
                                                                            <th scope="col">View</th>
                                                                        </tr>
                                                                        <tr id="hor-minimalist-c">
                                                                        	<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=patientSsn&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=patientSsn&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
																			<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=patientLastName&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=patientLastName&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0" border="0"/></a></td>
																			<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=patientGivenName&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=patientGivenName&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0" border="0"/></a></td>
																			<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=timeOfEvent&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=timeOfEvent&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
																			<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=createdDate&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=createdDate&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
																			<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=pouValue&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=pouValue&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
																			<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=consentType&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=consentType&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
																			<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=optoutReason&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=optoutReason&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
																			<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=userId&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=userId&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
																			<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=facilityName&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=facilityName&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
																			<td scope="col"><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=visnName&optInOptOutSortDirection=ASC"><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInOptOutReportResults.do_sec?optInOptOutSortValue=visnName&optInOptOutSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
																			<td scope="col"> </td>
																		</tr>
                                                                    </thead>
                                                                    <tbody>
                                                                        <pg:forEach var="r" items="${optInOptOutResults}" varStatus="i"
                                                                            paginator="${paginator}">
                                                                            <tr id="hor-minimalist-b">
                                                                                <td nowrap><%@include file="patientLink.jspf"%></td>
                                                                                <!-- Task # 303 -->
                                                                                <td>${r.lastName}</td>
                                                                                <td>${r.firstName}</td>
                                                                                <td><fmt:formatDate pattern="MM/dd/yyyy hh:mm a"
                                                                                        value="${r.auditTime}" />
                                                                                </td>
                                                                                <td><fmt:formatDate pattern="MM/dd/yyyy"
                                                                                        value="${r.patientDate}" />
                                                                                </td>
                                                                                <td>${r.purposeOfUse}</td>
                                                                                <td>${r.consentType}</td>
                                                                                <td>${r.inactivationReason}</td>
                                                                                <td>${r.userId}</td>
                                                                                <td>${r.facilityName}</td>
                                                                                <td>${r.visnName}</td>
                                                                                <td>
                                                                                    <c:choose>
                                                                                    <c:when test="${r.hasAttachment eq true}">
	                                                                                    <c:url var="url" value="OptInOptOutReportResults.do_sec">
	                                                                                        <c:param name="view" value="true" />
	                                                                                        <c:param name="documentUniqueId" value="${r.auditId}" />
	                                                                                    </c:url>
                                                                                    	<a alt="View" href="${url}">View</a>
                                                                                    </c:when>
                                                                                    <c:otherwise> <!--  there is a non-deliminated space there to make sure lines look appropriate when the jsp is rendered -->
                                                                                    </c:otherwise>
                                                                                    </c:choose>
																				</td>
                                                                            </tr>
                                                                        </pg:forEach>
                                                                    </tbody>
                                                                </table>
                                                                <pg:paginator paginator="${paginator}"
                                                                    uri="OptInOptOutReportResults.do_sec"
                                                                    results="${optInOptOutResults}" />
                                                            </c:when>
                                                            <c:otherwise>
                                                                    No records were found.
                                                                </c:otherwise>
                                                        </c:choose>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                        <!-- THE BODY CONTENT END -->
                                       </td>
                                 	</tr>
								</table>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <!-- START: PAGE FOOTER -->
                <%@include file="footer.jspf" %>
                <!-- END: PAGE FOOTER -->
                <!-- END: PAGE CONTENT -->
            </td>
        </tr>
    </tbody>
</table>
</body>
</html>