<%--
    Document   : Opt-in/Opt-out Summary Report
    Created By : 
    Modified By: 
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date" %>
<%@page import="java.util.*" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
        <head>
        <%@include file="metaCommon.jspf" %>
        <title>Veterans Authorization & Preferences Consent Directive Report</title>
        </head>
<body onload="setFocus(optInOptOutSummaryReportForm.startDate)">
<%@include file="header.jspf" %>
<table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes" id="main-content-table">
	<tbody>
    	<tr>
			<%@include file="leftMenu.jspf" %>
            <td id="content-va">
                <a name="content-area"></a>
                <!-- START: SITE NAME BAR -->
                <p class="title-bar"><!-- START: SITE NAME -->Consent Directive Summary Report<!-- END: SITE NAME --></p>
                <cpp:errors />
                <!-- END: SITE NAME BAR -->
                <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes">
                    <tbody>
                        <tr>
                            <td id="content-main">
                            	<table width="100%" summary="This table is used for layout purposes">
                                  <!-- START: PAGE TITLE AREA -->
                                  <!-- END: PAGE TITLE AREA -->
    	                          <tr>
	    		                      <td>
                			            <!-- START: PAGE CONTENT -->
                                        <table SUMMARY="This table is for formatting purposes only.">
                                            <tbody>
												<tr>
					                              <td id="content-page-content-title" width="100%"><font id="content-page-title-font">Fill in the fields below to narrow your search.
                                                                All dates will be included if Start Date and End Date are left blank.</font></td>
                				                </tr>
                              					<tr>
												    <td>
                                                        <div class="form-container">
                                                            <form name="optInOptOutSummaryReportForm" action="OptInOptOutSummaryReport.do_sec" method="POST" onsubmit="return doSubmit(this)">
                                                                <fieldset>
                                                                    <input type="hidden" id="consentTypeName" name="consentTypeName">
                                                                	<legend>Search Details</legend>
                                                                    	<div>
                                                                            <label for="startDate">Start Date <i><span style="font-weight:normal;">(mm/dd/yyyy)</span></i></label>
                                                                            <date:date id="startDate" name="startDate" />&nbsp;
                                                                    	</div>
                                                                    	<div>
                                                                            <label for="endDate">End Date <i><span style="font-weight:normal;">(mm/dd/yyyy)</span></i></label>
                                                                            <date:date id="endDate" name="endDate"  />&nbsp;
                                                                    	</div>
                                                                        <div>
																			<label alt="Query based on VA Facility from the dropdown list"  for="facility">VA Facility</label>
                                                                            <select id="facility" name="facility">
                                                                            	<option value="">ALL</option>
																				<c:forEach var="f" items="${facilities}">
																				<option value="${f.facilityName}"
																					<c:choose>
                                                     									<c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
	                                   								                      selected
	                                                       								</c:when>
                                                     								</c:choose>>
																					<c:choose>
																							<c:when test="${f.facilityName != ''}">
                                                        										 ${f.facilityName}
                                                      										</c:when>
																						<c:otherwise>
                                                         									${fn:split(f.facilityDns, '.')[0]}
                                                       									</c:otherwise>
																					</c:choose>
																					(${f.facilityStation})
																				</option>
																				</c:forEach>
																			</select>
																		</div>
                                                                        <div>
                                                                            <label for="consentType">Consent Type <span style="display:none;">"Query based on consent type from the dropdown list"</span></label>
                                                                            <select id="consentType" name="consentType" onchange="document.getElementById('consentTypeName').value = this.selectedOptions[0].text;">
                                                                                <option value="" selected>ALL</option>
                                                                                <option value="allAuthorizations">ALL Authorizations</option>
                                                                                <option value="allRevocations" >ALL Revocations</option>
                                                                                <option value="NwHINAuthorizations" >${organizationName} Authorizations</option>
                                                                                <option value="SSAAuthorizations" >SSA Authorizations</option>
                                                                                <option value="NwHINRevocations" >${organizationName} Revocations</option>
                                                                                <option value="SSARevocations" >SSA Revocations</option>
                                                                            	<option value="NwHINRestrictions" >${organizationName} Restrictions</option>
                                                                                <option value="NwHINRestrictionRevocations" >${organizationName} Restriction Revocations</option>
                                                                            </select>
                                                                            &nbsp;
                                                                        </div>
                                                                            <div>
                                                                                <label for="testPatients">Include Test Patients</label>
                                                                                <input type="checkbox" name="testPatients" id="testPatients" value="testPatients" alt="Check to Include the Test Patients"/>
                                                                            </div>
                                                                </fieldset>
                                                                <div class="buttonrow">
                                                                    <input name="search" alt="Search" class="button" type="submit" value="Search" />
                                                                </div>
                                                            </form>
                                                        </div>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                        <!-- THE BODY CONTENT END -->
                                       </td>
                                 	</tr>
								</table>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <!-- START: PAGE FOOTER -->
                <%@include file="footer.jspf" %>
                <!-- END: PAGE FOOTER -->
                <!-- END: PAGE CONTENT -->
            </td>
        </tr>
    </tbody>
</table>
</body>
</html>