<%-- 
    Document   : optInReport
    Created on : Dec 1, 2014
    Author     :                  
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
    <head>
        <script type="text/javascript" src="js/errors.js"></script>
        <%@include file="metaCommon.jspf" %>
        <title>Veterans Authorization & Preferences Opt-In Patients Report</title>
    </head>
    <body onload="setFocus(optInReportForm.facility)">
        <%@include file="header.jspf" %>
        <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes" id="main-content-table">
            <tbody>
                <tr>
                    <%@include file="leftMenu.jspf" %>
                    <td id="content-va">
                        <!-- START: PAGE CONTENT -->
                        <a name="content-area"></a>
                        <!-- START: SITE NAME BAR -->
                        <p class="title-bar">
                            <!-- START: SITE NAME -->Opt-In Patients Report<!-- END: SITE NAME -->
                        </p>
                        <cpp:errors/>
                        <!-- END: SITE NAME BAR -->
                        <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes">
                            <tbody>
                                <tr>
                                    <td id="content-main">
                                        <table width="100%" summary="This table is used for layout purposes">
                                            <!-- START: PAGE TITLE AREA -->
                                            <!-- END: PAGE TITLE AREA -->
                                            <tr>
                                                <td>
                                                    <!-- START: SEARCH FIELDS -->
                                                    <table SUMMARY="This table is for formatting purposes only.">
                                                        <tbody>
                                                            <tr>
                                                                <td id="content-page-content-title" width="100%"><font id="content-page-title-font">Fill in the fields below to narrow your search.</font></td>
                                                            </tr>
                                                            <tr>
                                                                <td>
                                                                    <div class="form-container">
                                                                        <form name="optInReportForm" action="OptInReport.do_sec" method="POST" onsubmit="return doSubmit(this)">
                                                                            <fieldset>
                                                                                <legend>Search Details</legend>
                                                                                <div>
                                                                                    <label for="facility">VA Facility<span style="display:none;">"Query based on VA Facility from the dropdown list"</span></label>
                                                                                    <select id="facility" name="facility">
                                                                                        <option value="">ALL</option>
                                                                                        <c:forEach var="f" items="${facilities}">
                                                                                            <option value="${f.facilityName}"
                                                                                                <c:choose>
                                                                                                    <c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
                                                                                                        selected
                                                                                                    </c:when>
                                                                                                </c:choose>>
                                                                                                <c:choose>
                                                                                                    <c:when test="${f.facilityName != ''}">
                                                                                                        ${f.facilityName}
                                                                                                    </c:when>
                                                                                                    <c:otherwise>
                                                                                                        ${fn:split(f.facilityDns, '.')[0]}
                                                                                                    </c:otherwise>
                                                                                                </c:choose>
                                                                                                (${f.facilityStation})
                                                                                            </option>
                                                                                        </c:forEach>
                                                                                    </select>
                                                                                </div>                                                                                
                                                                                <div>
                                                                                    <label for="consentTypeName">Consent Type<span style="display:none;">"Query based on consent type from the dropdown list"</span></label>
                                                                                    <select id="consentTypeName" name="consentTypeName">
                                                                                        <option value="" selected>ALL Authorizations</option>
                                                                                        <option value="NwHIN Authorization">${organizationName} Authorizations</option>
                                                                                        <option value="SSA Authorization">SSA Authorizations</option>
                                                                                    </select>
                                                                                </div>
                                                                                <div>
                                                                                    <label for="enteredBy">Entered By<span style="display:none;">"Query based on whom entered information from the dropdown list"</span></label>
                                                                                    <select id="enteredBy" name="enteredBy">
                                                                                        <option value="" selected>ALL</option>
                                                                                        <option value="eBenefits">eBenefits</option>
                                                                                        <option value="employee">Employee</option>
                                                                                    </select>
                                                                                </div>
                                                                                <div>
                                                                                    <label for="recordsPerPage">Records Per Page<span style="display:none;">"Choose the number of records you want to view from the dropdown list"</span></label>
                                                                                    <select id="recordsPerPage" name="recordsPerPage">
                                                                                        <option value="10">10</option>
                                                                                        <option value="25" selected>25</option>
                                                                                        <option value="50">50</option>
                                                                                        <option value="100">100</option>
                                                                                        <option value="-1">ALL</option>
                                                                                    </select>
                                                                                </div>
                                                                                <div>
                                                                                    <label for="testPatients">Include Test Patients</label>
                                                                                    <c:choose>
                                                                                        <c:when test="${testPatients}"><input type="checkbox" name="testPatients" id="testPatients" value="testPatients" checked="true" alt="Check to Include the Test Patients"/></c:when>
                                                                                        <c:otherwise><input type="checkbox" name="testPatients" id="testPatients" value="testPatients" alt="Check to Include the Test Patients"/></c:otherwise>
                                                                                    </c:choose>
                                                                                </div>                                                                                        
                                                                            </fieldset>
                                                                            <div class="buttonrow">
                                                                                <input name="search" alt="Search" class="button" type="submit" value="Search"/>
                                                                            </div>
                                                                        </form>
                                                                    </div>
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                    <!-- END: SEARCH FIELDS -->
                                                </td>
                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <!-- START: PAGE FOOTER -->
                        <%@include file="footer.jspf" %>
                        <!-- END: PAGE FOOTER -->
                        <!-- END: PAGE CONTENT -->
                    </td>
                </tr>
            </tbody>
        </table>
    </body>
</html>
