<%--
    Document   : Patient Discovery Report
    Created By : 
    Modified By: 
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
<head>
<title>Veterans Authorization & Preferences Patient Discovery
	Audit Report</title>
<%@include file="metaCommon.jspf"%>
</head>
<body onload="setFocus(patientDiscoveryReportForm.ssn)">
	<%@include file="header.jspf"%>
	<table border="0" cellpadding="0" cellspacing="0" width="100%"
		summary="table is used for layout purposes" id="main-content-table">
		<tbody>
			<tr>
				<%@include file="leftMenu.jspf"%>
				<td id="content-va"><a name="content-area"></a> <!-- START: SITE NAME BAR -->
					<p class="title-bar">
						<!-- START: SITE NAME -->
						Patient Discovery Audit Report
						<!-- END: SITE NAME -->
					</p> <cpp:errors /> <!-- END: SITE NAME BAR -->
					<table border="0" cellpadding="0" cellspacing="0" width="100%"
						summary="table is used for layout purposes">
						<tbody>
							<tr>
								<td id="content-main">
									<table width="100%"
										summary="This table is used for layout purposes">
										<!-- START: PAGE TITLE AREA -->
										<!-- END: PAGE TITLE AREA -->
										<tr>
											<td>
												<!-- START: PAGE CONTENT -->
												<table SUMMARY="This table is for formatting purposes only.">
													<tbody>
														<tr>
															<td id="content-page-content-title" width="100%"><font
																id="content-page-title-font">Fill in the fields
																	below to narrow your search. All dates will be included
																	if Start Date and End Date are left blank.</font></td>
														</tr>
														<tr>
															<td>
																<div class="form-container">
																	<form name="patientDiscoveryReportForm"
																		action="PatientDiscoveryReport.do_sec" method="POST"
																		onsubmit="return doSubmit(this)">
																		<fieldset>
                                                                                                                                                    <input type="hidden" id="organizationName" name="organizationName">
																			<legend>Search Details</legend>
                                                                            <div>
                                                                              <label for="ssn">SSN <i><span style="font-weight:normal;">(#########)</span></i></label>
                                                                              <input alt="Enter SSN. Enter numbers only no hyphens" id="ssn" name="ssn" type="text" maxlength="9" size="9" /> <i><span style="font-weight:normal;"> (Enter numbers only, no hyphens.)</span></i> &nbsp;
                                                                            </div>
                                                                            <div>
                                                                              <label for="lastName">Last Name</label>
                                                                              <input alt="Enter Last Name" id="lastName" name="lastName" type="text" maxlength="255" size="30" />
                                                                            </div>
                                                                            <div>
                                                                              <label for="firstName">First Name</label>
                                                                              <input alt="Enter First Name" id="firstName" name="firstName" type="text" maxlength="255" size="30" />
                                                                            </div>
																			<div>
																				<label for="startDate">Start Date <i><span style="font-weight:normal;">(mm/dd/yyyy)</span></i></label>
																				<date:date id="startDate" name="startDate" />&nbsp;
																			</div>
																			<div>
																				<label for="endDate">End Date <i><span style="font-weight:normal;">(mm/dd/yyyy)</span></i></label>
																				<date:date id="endDate" name="endDate" />&nbsp;
																			</div>
																			<div>
																				<label alt="Query based on MPI results from the dropdown list" for="mpiMatch">MPI Results</label> <select
																					id="mpiMatch" name="mpiMatch">
																					<option value="ALL">ALL</option>
																					<option value="MATCH FOUND">Match Found</option>
																					<option value="MATCH FAILED">Match Failed</option>
																				</select>
																			</div>
																			<div>
																				<label alt="Query based on ${organizationName} Organization from the dropdown list" for="organization">${organizationName} Organization</label>
																				<select id="organization" name="organization" onchange="document.getElementById('organizationName').value = this.selectedOptions[0].text;">
																					<option value="">ALL</option>
																					<c:forEach var="r" items="${organizations}">
																						<option value="%${r.orgOid}">${r.orgName}</option>
																					</c:forEach>
																				</select>
																			</div>
																			
																			<div>
																				<label alt="Choose the number of records you want to view from the dropdown list" for="recordsPerPage">Records Per Page</label>
																				<select id="recordsPerPage" name="recordsPerPage">
																					<option value="10">10</option>
																					<option value="25" selected>25</option>
																					<option value="50">50</option>
																					<option value="100">100</option>
																					<option value="-1">ALL</option>
																				</select>
																			</div>
                                                                            <div>
                                                                                    <label for="testPatients">Include Test Patients</label>
                                                                                    <input type="checkbox" name="testPatients" id="testPatients" value="testPatients" alt="Check to Include the Test Patients"/>
                                                                                </div>
                                                                        </fieldset>
																		<div class="buttonrow">
																			<input name="search" alt="Search" class="button" type="submit"
																				value="Search" />
																		</div>
																	</form>
																</div>
															</td>
														</tr>
													</tbody>
												</table> <!-- THE BODY CONTENT END -->
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</tbody>
					</table> <!-- START: PAGE FOOTER --> <%@include file="footer.jspf"%>
					<!-- END: PAGE FOOTER --> <!-- END: PAGE CONTENT -->
				</td>
			</tr>
		</tbody>
	</table>
</body>
</html>
