<%-- 
    Document   : patientDiscoverySummaryReport
    Created on : Jun 5, 2015, 12:04:48 PM
    Author     :                  
--%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>
<%@page import="java.util.*"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
        <%@include file="metaCommon.jspf" %>
        <title>Veterans Authorization & Preferences Patient Discovery Audit Summary Report</title>
    </head>
    <body onload="setFocus(reportForm.startDate)">
        <%@include file="header.jspf" %>
        <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes" id="main-content-table">
            <tbody>
                <tr>
                    <%@include file="leftMenu.jspf" %>
                    <td id="content-va">
                        <a name="content-area"></a>
                        <!-- START: SITE NAME BAR -->
                        <p class="title-bar"><!-- START: SITE NAME -->Patient Discovery Summary Report<!-- END: SITE NAME --></p>
                        <cpp:errors />
                        <!-- END: SITE NAME BAR -->
                        <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="This table is used for layout purposes">
                            <tbody>
                                <tr>
                                    <td id="content-main">
                                        <table width="100%" summary="This table is used for layout purposes">
                                            <!-- START: PAGE TITLE AREA -->
                                            <!-- END: PAGE TITLE AREA -->
                                            <tr>
                                                <td>
                                                    <!-- START: SEARCH AREA -->
                                                    <table summary="This table is for formatting purposes">
                                                        <tbody>
                                                            <tr>
                                                                <td id="content-page-content-title" width="100%">
                                                                    <font id="content-page-title-font">Fill in the fields below to narrow your search.
                                                                        All dates will be included if Start Date and End Date are left blank.</font>
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td>
                                                                    <div class="form-container">
                                                                        <form name="reportForm" action="PatientDiscoverySummaryReport.do_sec" method="POST" onsubmit="return doSubmit(this)">
                                                                            <fieldset>
                                                                                <input type="hidden" id="organizationName" name="organizationName">
                                                                                <input type="hidden" id="facilityName" name="facilityName">
                                                                                <legend>Search Details</legend>
                                                                                <div>
                                                                                    <label for="startDate">Start Date <i><span style="font-weight:normal;">(mm/dd/yyyy)</span></i></label>
                                                                                    <date:date id="startDate" name="startDate" />&nbsp;
                                                                                </div>
                                                                                <div>
                                                                                    <label for="endDate">End Date <i><span style="font-weight:normal;">(mm/dd/yyyy)</span></i></label>
                                                                                    <date:date id="endDate" name="endDate"  />&nbsp;
                                                                                </div>
                                                                                <div>
                                                                                    <label alt="Query based on VA Facility from the dropdown list"  for="facility">VA Facility</label>
                                                                                    <select id="facility" name="facility" onchange="document.getElementById('facilityName').value = this.selectedOptions[0].text;">
                                                                                        <option value="">ALL</option>
                                                                                        <c:forEach var="f" items="${facilities}">
                                                                                            <option value="${f.facilityStation}"
                                                                                                <c:choose>
                                                                                                    <c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
                                                                                                        selected
                                                                                                    </c:when>
                                                                                                </c:choose>>
                                                                                                <c:choose>
                                                                                                    <c:when test="${f.facilityName != ''}">
                                                                                                        ${f.facilityName}
                                                                                                    </c:when>
                                                                                                    <c:otherwise>
                                                                                                        ${fn:split(f.facilityDns, '.')[0]}
                                                                                                    </c:otherwise>
                                                                                                </c:choose>
                                                                                                (${f.facilityStation})
                                                                                            </option>
                                                                                        </c:forEach>
                                                                                    </select>
                                                                                </div>
                                                                                <div>
                                                                                    <label alt="Query based on ${organizationName} Organization from the dropdown list" for="organization">${organizationName} Organization</label> 
                                                                                    <select id="organization" name="organization" onchange="document.getElementById('organizationName').value = this.selectedOptions[0].text;">
                                                                                        <option value="" selected>ALL</option>
                                                                                        <c:forEach var="r" items="${organizations}">
                                                                                            <option value="%${r.orgOid}">${r.orgName}</option>
                                                                                        </c:forEach>
                                                                                    </select>
                                                                                </div>                                                                                
                                                                            </fieldset>
                                                                            <div class="buttonrow">
                                                                                <input name="search" alt="Search" class="button" type="submit" value="Search" />
                                                                            </div>
                                                                        </form>
                                                                    </div>
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                    <!-- END: SEARCH AREA -->
                                                </td>
                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <!-- START: PAGE FOOTER -->
                        <%@include file="footer.jspf" %>
                        <!-- END: PAGE FOOTER -->
                    </td>
                </tr>
            </tbody>
        </table>
    </body>
</html>
