<%-- 
    Document   : patientDiscoverySummaryReportResults
    Created on : Jun 5, 2015, 1:23:12 PM
    Author     :                  
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/paginator" prefix="pg"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
    <head>
        <title>Veterans Authorization & Preferences Consent Directive Report Results</title>
        <%@include file="metaCommon.jspf" %>
    </head>
<body>
<%@include file="header.jspf" %>
<table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes" id="main-content-table">
    <tbody>
        <tr>
            <%@include file="leftMenu.jspf" %>
            <td id="content-va">
                <a name="content-area"></a>
                <!-- START: SITE NAME BAR -->
                <p class="title-bar"><!-- START: SITE NAME -->Patient Discovery Audit Summary Report<!-- END: SITE NAME --></p>
                <cpp:errors />
                <!-- END: SITE NAME BAR -->
                <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes">
                    <tbody>
                        <tr>
                            <td id="content-main">
                                <table width="100%" summary="This table is used for layout purposes">
                                    <!-- START: PAGE TITLE AREA -->
                                    <!-- END: PAGE TITLE AREA -->
                                    <tr>
                                        <td>
                                            <!-- START: REPORT CONTENT -->
                                            <table SUMMARY="This table is for formatting purposes only.">
                                                <tbody>
                                                    <tr>
                                                        <td>
                                                            <table id="ver-minimalist">
                                                                <tbody>
                                                                    <tr> <a href="PatientDiscoverySummaryReportResults.do_sec?exportToExcel=true">
                                                                        <input name="exportToExcel" alt="Export to Excel" class="button" type="submit"
                                                                            value="Export to Excel" /></a></tr>
                                                                    <tr>
                                                                        <td>
                                                                        <td>Start Date</td>
                                                                        <td><c:choose>
                                                                            <c:when test="${!empty patientDiscoverySummaryQueryStartDate}">
                                                                                <fmt:formatDate pattern="MM/dd/yyyy" value="${patientDiscoverySummaryQueryStartDate}"/>
                                                                            </c:when>
                                                                            <c:otherwise>
                                                                                N/A
                                                                            </c:otherwise>
                                                                         </c:choose>
                                                                        </td>
                                                                        <td>End Date</td>
                                                                        <td><c:choose>
                                                                            <c:when test="${!empty patientDiscoverySummaryQueryEndDate}">
                                                                                <fmt:formatDate pattern="MM/dd/yyyy" value="${patientDiscoverySummaryQueryEndDate}"/>
                                                                            </c:when>
                                                                            <c:otherwise>
                                                                                N/A
                                                                            </c:otherwise>
                                                                            </c:choose>
                                                                        </td>
                                                                    </tr>
                                                                </tbody>
                                                            </table>
                                                            <c:choose>
                                                                <c:when test="${!empty patientDiscoverySummaryResults}">
                                                                    <br/>
                                                                    <table>
                                                                        <thead>
                                                                            <tr id="hor-minimalist-c">
                                                                                <th scope="col">${organizationName} Organization</th>
                                                                                <th scope="col">VA Facility</th>
                                                                                <th scope="col">Audits</th>
                                                                                <th scope="col">Unique Real Patients</th>
                                                                                <th scope="col">Matches Found for Real Patients</th>
                                                                                <th scope="col">Match Fails for Real Patients</th>
                                                                                <th scope="col">Unique Test Patients</th>
                                                                                <th scope="col">Matches Found for Test Patients</th>
                                                                                <th scope="col">Match Fails for Test Patients</th>
                                                                            </tr>
                                                                        </thead>
                                                                        <tbody>
                                                                            <pg:forEach var="r" items="${patientDiscoverySummaryResults}" varStatus="i" paginator="${paginator}">
                                                                                <tr id="hor-minimalist-b">
                                                                                    <td>${r.partnerOrg}</td>
                                                                                    <td>${r.vaFacility}</td>
                                                                                    <td>${r.auditsCount}</td>
                                                                                    <td>${r.countUniqueRealPatients}</td>
                                                                                    <td>${r.matchesFoundRealPatients}</td>
                                                                                    <td>${r.matchFailsRealPatients}</td>
                                                                                    <td>${r.countUniqueTestPatients}</td>
                                                                                    <td>${r.matchesFoundTestPatients}</td>
                                                                                    <td>${r.matchFailsTestPatients}</td>
                                                                                </tr>
                                                                            </pg:forEach>
                                                                        </tbody>
                                                                    </table>
                                                                </c:when>
                                                                <c:otherwise>
                                                                    No records were found.
                                                                </c:otherwise>
                                                            </c:choose>
                                                        </td>
                                                    </tr>
                                                </tbody>
                                            </table>
                                            <c:if test="${!empty totalCount && !empty patientDiscoverySummaryResults}">
                                                <div><b>Total audits: </b>${totalCount}</div>
                                            </c:if>
                                            <!-- END: REPORT CONTENT -->
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <!-- START: PAGE FOOTER -->
                <%@include file="footer.jspf" %>
                <!-- END: PAGE FOOTER -->
                <!-- END: PAGE CONTENT -->
            </td>
        </tr>
    </tbody>
</table>
</body>
</html>