<%--
    Document   : Patient Search
    Created By : 
    Modified By: 
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<style>

.popup {
	background: #E4E4E4;
    border: 1px solid gray;
    color: #083084;
    height: auto;
	padding: 8px;
	position: fixed;
    right: 0px;
    top: 225px;
    transform: translate(100%, 0);
    width: auto;
    -webkit-box-sizing: border-box;
       -moz-box-sizing: border-box;
        -ms-box-sizing: border-box;
            box-sizing: border-box;
    -webkit-transition: -webkit-transform .5s ease;
       -moz-transition:    -moz-transform .5s ease;
        -ms-transition:     -ms-transform .5s ease;
            transition:         transform .5s ease;

}

.opened {
    -webkit-transform: translate(0%, 0);
       -moz-transform: translate(0%, 0);
        -ms-transform: translate(0%, 0);
            transform: translate(0%, 0);

}

.closed {
    -webkit-transform: translate(100%, 0);
       -moz-transform: translate(100%, 0);
        -ms-transform: translate(100%, 0);
            transform: translate(100%, 0);
}

</style>

<html lang="en">
        <head>
        <title>Veterans Authorizations and Preferences Search</title>
        <%@include file="metaCommon.jspf" %>
        </head>

        <body onload="setFocus(patientSearchForm.ssn)">
        <%@include file="header.jspf" %>
        <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes" id="main-content-table">
          <tbody>
            <tr>
              <%@include file="leftMenu.jspf" %>
              <td id="content-va"><a name="content-area"></a>

                <!-- START: SITE NAME BAR -->

                <p class="title-bar"><!-- START: SITE NAME -->Patient Search<!-- END: SITE NAME --></p>
                <cpp:errors />

                <!-- END: SITE NAME BAR -->

                <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes">
                  <tbody>
                    <tr>
                      <td id="content-main"><table width="100%" summary="This table is used for layout purposes">
                          <!-- START: PAGE TITLE AREA -->
                          <!-- END: PAGE TITLE AREA -->
                          <tr>
                          <td><!-- START: PAGE CONTENT -->

                              <table SUMMARY="This table is for formatting purposes only.">
                              <tr>
	                              <td id="content-page-content-title" width="100%"><font id="content-page-title-font">Enter the Social Security number, last name, and first name of the patient for whom you are searching and click Search.</font></td>
                                </tr>
                              <tr>
                                  <td><div class="form-container">
                                      <form name="patientSearchForm" action="PatientSearch.do_sec" method="POST" onsubmit="return doSubmit(this)">
                                      <fieldset>
                                          <legend>Search for a patient</legend>
                                          <div>
                                          <label for="ssn">SSN <i><span style="font-weight:normal;">(#########)</span></i><img alt="Required field" src="res/star-icon_white_bg.png"/></label>
                                          <input alt="Enter SSN. required field. Enter numbers only no hyphens" id="ssn" name="ssn" type="text" maxlength="9" size="9" /> <i><span style="font-weight:normal;"> (Enter numbers only, no hyphens.)</span></i> &nbsp;
                                        </div>
                                          <div>
                                          <label for="lastName">Last Name<img alt="Required field" src="res/star-icon_white_bg.png"/></label>
                                          <input alt="Enter Last Name. required field"id="lastName" name="lastName" type="text" maxlength="255" size="30" />
                                        </div>
                                          <div>
                                          <label for="firstName">First Name<img alt="Required field" src="res/star-icon_white_bg.png"/></label>
                                          <input alt="Enter First Name required field"id="firstName" name="firstName" type="text" maxlength="255" size="30" />
                                        </div>
                                        </fieldset>
                                      <div class="buttonrow">
                                          <input name="search" alt="Search" class="button" type="submit" value="Search" />
                                        </div>
                                    </form>
                                    </div></td>
                                </tr>
                            </table>

                              <!-- END: PAGE CONTENT --></td>
                        </tr>
                        </table>
                        </td>
                    </tr>
                  </tbody>
                </table>
                <!-- START: PAGE FOOTER -->
                <%@include file="footer.jspf" %>
                <!-- END: PAGE FOOTER -->
                </td>
            </tr>
        </tbody>
    </table>
    <c:if test="${announcementSent}">
        <div id='popup' class="popup">
            Patient announcement started. You may<br>
            move on to another announcement or activity.
        </div>
    </c:if>
</body>
<c:if test="${announcementSent}">
    <script language="JavaScript">
        var hasCssTransitionSupport = detectCSSFeature("transition");
        var popup = document.getElementById('popup');
        if (hasCssTransitionSupport === false) {
            popup.style.display = 'none';
        }
        window.setTimeout(showPopup, 500);

        function showPopup() {
            if (hasCssTransitionSupport) {
                popup.classList.add('opened');
            } else {
                popup.style.display = '';
            }
            window.setTimeout(hidePopup, 4000);
        }

        function hidePopup() {
            if (hasCssTransitionSupport) {
                popup.classList.remove('opened');
                popup.classList.add('closed');
            } else {
                popup.style.display = 'none';
            }
        }

        function detectCSSFeature(featureName){
            var hasFeature = false;
            var domPrefixes = 'Webkit Moz ms O'.split(' ');
            var elem = document.createElement('div');
            var featureNameCapital = null;

            featureName = featureName.toLowerCase();

            if (elem.style[featureName] !== undefined) {
                hasFeature = true;
            }

            if (!hasFeature) {
                featureNameCapital = featureName.charAt(0).toUpperCase() + featureName.substr(1);
                for (var i = 0; i < domPrefixes.length; i++) {
                    if (elem.style[domPrefixes[i] + featureNameCapital ] !== undefined) {
                        hasFeature = true;
                        break;
                    }
                }
            }
            return hasFeature;
        }

        <%session.setAttribute("announcementSent", "false");%>
    </script>
</c:if>
</html>
