<%--
    Document   : Not Authorized Page
    Author     : 
    Edited     :               
--%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>


<html lang="en">
<head>
<%@include file="metaCommon.jspf"%>
<title>Veterans Authorization & Preferences - Revoke ${organizationName}
	Organization Restriction</title>
<SCRIPT LANGUAGE="JavaScript">
	opt.init(document.multiSelectListForm);
</SCRIPT>
</head>
<body
	onLoad="opt.init(document.multiSelectListForm); setFocus(multiSelectListForm.authenticatingFacility);">
	<table>
		<tr>
			<td>
				<p class="detailText">
					The Veteran requests and authorizes VA to revoke ALL restrictions
					previously submitted on the release of his/her personal health
					information for treatment purposes to non-VA health care provider
					organizations through ${organizationName}. By revoking all restrictions 
					requests, the sharing of Veteran electronic health information to 
					non-VA health care provider organizations through ${organizationName} 
					is no longer restricted or limited in any way. <br />
				</p>
				<p class="detailText">The VA Form 10-0525 for the revocation of
					Veteran restriction request for sharing of his/her electronic
					health information with non-VA health care provider organizations
					participating in ${organizationName} and partnering with VA for 
					treatment purposes has been validated and verified. The sharing 
					of Veteran electronic health information is no longer restricted 
					or limited in any way.</p>

				</td>
		</tr>
		<tr>
			<td>
				<div class="form-container">
					<fieldset>
						<legend>Revoke or Terminate</legend>
						<table>
							<tr>
								<td><input
									alt="Choose the radio button to select Patient revokes
								access to all ${organizationName} Providers
								and Organizations"
									type="radio" name="consentGroup" value="revoke" checked>Patient revokes restrictions to all non-VA healthcare providers and Organizations. <br /> <br />
								
								<p class="detailText">* NOTE: Revoke does not restrict sharing of patient information with DoD, VA patient
									information is always shared with the DoD.</p>
								</td>
							</tr>
							<tr>
								<td><form name="multiSelectListForm"
										id="multiSelectListForm" action="PatientDetails.do_sec"
										method="POST" onsubmit="onRevoke(); return doSubmit(this);"
										enctype="multipart/form-data">
										<input type="hidden" name="icn"
											value="${patientDemographics.icn}" /> <input type="hidden"
											name="requestId" value="${requestId}" /> <input
											type="hidden" name="patientId"
											value="${consentDirective.patientIen}" /> <INPUT
											TYPE="hidden" NAME="consentType"
											VALUE="NwHIN Organization Restriction Revocation" /> <INPUT
											TYPE="hidden" NAME="purposeOfUse" VALUE="TREATMENT" />
										<div id="multiSelectAuthorizeForm">
											<table bgcolor="#eff2ff">
												<TR>
													<TD><b>All Providers and Organizations (unrestricted)</b>
													</TD>
													<TD>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
													<TD><b>${organizationName} Providers and Organizations who will
															NOT have access to your records (restricted)</b>
													</TD>
												</TR>
												<TR>
													<TD><SELECT
														title="All Providers and Organizations list box"
														style="width: 310px;" class="listSelect" NAME="list1"
														id="list1" multiple="true" size="10">
															<c:if test="${!empty authorizedOrganizations}">
																<c:forEach var="r" items="${authorizedOrganizations}"
																	varStatus="i">
																	<c:choose>
																		<c:when test="${r.orgNumber eq  '200DOD'}">
																			<option value="${r.orgNumber}">* ${r.orgName}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
																		</c:when>
																		<c:otherwise>
																			<option value="${r.orgNumber}">${r.orgName}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
																		</c:otherwise>
																	</c:choose>
																</c:forEach>
															</c:if>
													</SELECT>
													</TD>
													<TD VALIGN="MIDDLE" ALIGN="LEFT"><INPUT
														style="width: 125px; height: 30px;" TYPE="button"
														alt="Move All"
														title="Move all the Organizations to the right box"
														class="midButton" NAME="right" VALUE="Move All &gt;&gt;"
														ONCLICK="opt.transferAllRight()" disabled="disabled"><BR>
														<INPUT TYPE="button" alt="Move Selected to right "
														title="Move the Selected Organizations to the right box"
														class="midButton" disabled="disabled"
														style="width: 125px; height: 30px;" NAME="right"
														VALUE="Move Selected &gt;" ONCLICK="opt.transferRight()">
														<BR> <BR> <INPUT TYPE="button"
														alt="Move selected to left"
														title="Move the selected Organizations to the left box"
														class="midButtonLeft" disabled="disabled"
														style="width: 125px; height: 30px;" NAME="left"
														VALUE="&lt; Move Selected" ONCLICK="opt.transferLeft()">
														<br /> <INPUT TYPE="button" alt="Clear"
														title="Clear all selections" class="midButton" NAME="left"
														style="width: 125px; height: 30px;" disabled="disabled"
														VALUE="Clear" ONCLICK="opt.transferAllLeft()">
													</TD>

													<TD><SELECT
														title="${organizationName} Providers and Organizations who will
															NOT have access to your records list box"
														NAME="list2" class="listSelect" multiple="true" size="10"
														id="list2" style="width: 310px;">
															<c:if test="${!empty excludedOrganizations}">
																<c:forEach var="r" items="${excludedOrganizations}"
																	varStatus="i">
																	<option value="${r.orgNumber}">${r.orgName}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
																</c:forEach>
															</c:if>
													</SELECT></TD>
												</TR>
											</table>
										</div>

										<div>
											<label>Authenticating
												Facility <img alt="Required field" src="res/star-icon_grey_bg.png" /><span
												style="display: none;">Authenticating Facility
													required field</span> </label> <select id="authenticatingFacility" 
													 name="userFacility">
												<c:forEach var="f" items="${allowedFacilities}">
													<option value="${f.facilityStation}"
														<c:choose>
                                                     		<c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
	                                                         selected
	                                                        </c:when>
                                                     		<c:when test="${cookie.facility.value == f.facilityStation}">
	                                                         selected
	                                                         </c:when>
                                                     	</c:choose>>
														<c:choose>
															<c:when test="${f.facilityName != ''}">
	                                                         ${f.facilityName}
	                                                       </c:when>
															<c:otherwise>
	                                                         ${fn:split(f.facilityDns, '.')[0]}
	                                                       </c:otherwise>
														</c:choose>
														(${f.facilityStation})
													</option>
												</c:forEach>
											</select> <br /> <br />
										</div>
										<div id="revokeForm">
											<div>
												<label for="reason">Inactivation Reason<img
													alt="Required field" src="res/star-icon_grey_bg.png" /> </label> <select
													id="reason" name="reason"
													onchange="onOptoutReasonChange(this);">
													<option
														alt="Select a Opt out reason from the dropdown list"
														value="">--Select a reason--</option>
													<c:if test="${!empty optOutReasons}">
														<c:forEach var="r" items="${optOutReasons}" varStatus="i">
															<c:choose>
																<c:when test="${r eq 'New Authorization'}">
																</c:when>
																<c:otherwise>
																	<option value="${r}">${r}</option>
																</c:otherwise>
															</c:choose>
														</c:forEach>
													</c:if>
												</select>
											</div>
											<br />
											<div id="revokeValidationCheckBox" style="display: none;">
												<label>10-0525 Form Validation<img
													alt="Required field" src="res/star-icon_grey_bg.png" /> <span
													style="display: none;">Form Validation required
														field</span>
												</label> <input id="revokeValidationCheckBoxInput"
													type="checkbox"
													alt="select Form Validation checkbox if Revocation Form 10-0525 was received and validated. required field"
													onclick="enableRevokeAfterValidation('signatureDate', 'Revoke');"
													name="option1"
													value="Revocation Form Received and Validated">Revocation
												Form Received and Validated &nbsp; <br /> <br />

											</div>

											<div id="revokeDateAndUploadValidation"	style="display: none;">
												<div>
													<label>Patient Signature Date<img
														alt="Required field" src="res/star-icon_grey_bg.png" /> <i><span
															style="display: none;"> Patient Signature Date
														required field</span><span style="font-weight: normal;">(mm/dd/yyyy)&nbsp;
														&nbsp;</span> </i> </label> <span style="display: none;">Patient
														Signature Date required field</span>
													<date:date id="signatureDate" name="signatureDate" onkeyup="enableRevokeAfterValidation('signatureDate', 'Revoke');"/>
													&nbsp; <br /> <br />
												</div>
												<c:choose>
													<c:when test="${isFormUploadAllowed}">
														<div>
															<label for="file">Upload Consent Form<br /> <i><span
																	style="font-weight: normal;">(Max file size:
																		${maxFileUploadSize/1000000} megabytes)</span> </i> </label><input
																alt="Browse and Upload Consent Form" name="uploaded"
																type="file" id="file" accept="application/pdf" />&nbsp;
														</div>
													</c:when>
												</c:choose>
											</div>
											<div id="revokeDateAndUploadValidationPatientDeceased" style="display: none;">
												<div>
													<label>Patient Deceased Date<img
												alt="Required field" src="res/star-icon_grey_bg.png" /> <i><span
													style="display: none;"> Patient Deceased Date
														required field</span><span style="font-weight: normal;">(mm/dd/yyyy)&nbsp;
														&nbsp;</span> </i> </label> <span style="display: none;">Patient
												Deceased Date required field</span>
													<date:date id="deceasedDate" name="deceasedDate" onkeyup="enableRevokeAfterValidation('deceasedDate', 'Revoke');"/>
													&nbsp; <br /> <br />
												</div>
											</div>
                                                                                        <div>
                                                                                            <label for="comments">Comments</label>
                                                                                            <span style="display: none;">Patient Comments not a required field</span>
                                                                                            <textarea id="comments" name="comments" style="width: 300px; height: 60px;"></textarea>
                                                                                            <br />
                                                                                        </div>
											<br />
											<div align="center" id="revokeButton" style="display:">
												<INPUT id="Revoke" alt="Revoke" class="button"
													disabled="disabled" TYPE="SUBMIT" VALUE="Revoke"
													name="optOut" onClick="enableAllElements()">
											</div>
										</div>
									</form>
								</td>
							</tr>
						</table>
					</fieldset>
				</div>
			</td>
		</tr>
	</table>
</body>
</html>