<%--
    Document   : Not Authorized Page
    Author     : 
    Edited     :               
--%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>


<html lang="en">
<head>
<%@include file="metaCommon.jspf"%>
<title>Veterans Authorization & Preferences - ${organizationName} Revocation</title>
</head>
<body onLoad="setFocus(multiSelectListForm.authenticatingFacility);">

	<table>
		<tr>
			<td>
				<p class="detailText">The Veteran is revoking Social
				Security Administration authorization. By revoking this
				authorization the Veteran understands that the sharing
				of his/her electronic health information with Social
				Security Administration through ${organizationName} for disability
				determination (coverage) will stop. </p>
				<p class="detailText">To revoke this authorization, check
					the box and enter the Patient Signature Date and click <b>Revoke</b>.</p>
				<p class="detailText">To submit a new authorization, select New Authorization as the “Inactivation Reason” 
				and enter the Patient Signature Date for the new authorization form received.</p></td>
		</tr>
		<tr>


			<td>
				<div class="form-container">
					<fieldset>
						<legend>Revoke</legend>
						<table>
							<tr>
								<td><input
									alt="Choose the radio button to select Patient revokes
								access to all ${organizationName} Providers
								and Organizations"
									type="radio" name="consentGroup" value="revoke" checked>Patient
									revokes sharing of protected health information to SSA through
									${organizationName}.<br /> <br />
								</td>
							</tr>
							<tr>
								<td><form name="multiSelectListForm"
										id="multiSelectListForm" action="PatientDetails.do_sec"
										method="POST" onsubmit="onRevoke(); return doSubmit(this);"
										enctype="multipart/form-data">
										<input type="hidden" name="icn"
											value="${patientDemographics.icn}" /> <input type="hidden"
											name="requestId" value="${requestId}" /> <input
											type="hidden" name="patientId"
											value="${consentDirective.patientIen}" /> <INPUT
											TYPE="hidden" NAME="consentType" VALUE="SSA Revocation" />
											<INPUT
											TYPE="hidden" NAME="purposeOfUse" VALUE="COVERAGE" />
											<INPUT TYPE="hidden" NAME="expirationYears" VALUE="2" />

										<div>
											<label>Authenticating
												Facility <img alt="Required field" src="res/star-icon_grey_bg.png" /><span
												style="display: none;">Authenticating Facility
													required field</span> </label> <select id="authenticatingFacility"
													 name="userFacility">
												<c:forEach var="f" items="${allowedFacilities}">
													<option value="${f.facilityStation}"
														<c:choose>
                                                     		<c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
	                                                         selected
	                                                        </c:when>
                                                     		<c:when test="${cookie.facility.value == f.facilityStation}">
	                                                         selected
	                                                         </c:when>
                                                     	</c:choose>>
														<c:choose>
															<c:when test="${f.facilityName != ''}">
	                                                         ${f.facilityName}
	                                                       </c:when>
															<c:otherwise>
	                                                         ${fn:split(f.facilityDns, '.')[0]}
	                                                       </c:otherwise>
														</c:choose>
														(${f.facilityStation})
													</option>
												</c:forEach>
											</select> <br /> <br />
										</div>
										<div id="revokeForm">
											<div>
												<label for="reason">Inactivation Reason<img
													alt="Required field" src="res/star-icon_grey_bg.png" /> </label> <select
													id="reason" name="reason"
													onchange="onOptoutReasonChange(this);" onkeyup="onOptoutReasonChange(this);">
													<option
														alt="Select a Opt out reason from the dropdown list"
														value="">--Select a reason--</option>
													<c:if test="${!empty optOutReasons}">
														<c:forEach var="r" items="${optOutReasons}" varStatus="i">
															<c:choose>
																<c:when test="${r eq 'New Authorization'}">
																	<c:if test="${isSSANewAuthorizationAllowed eq true}">
																		<option value="${r}">${r}</option>
																	</c:if>
																</c:when>
																<c:otherwise>
																	<option value="${r}">${r}</option>
																</c:otherwise>
															</c:choose>
														</c:forEach>
													</c:if>
												</select>
											</div>
											<br />
											<div id="revokeValidationCheckBox" style="display: none;">
												<label>10-0484a Form Validation <img
													alt="Required field" src="res/star-icon_grey_bg.png" /> <span
													style="display: none;">Form Validation required
														field</span> </label> <input id="revokeValidationCheckBoxInput" type="checkbox"
													alt="select Form Validation checkbox if Revocation Form 10-0484a was received and validated. required field"
													onclick="enableRevokeAfterValidation('signatureDate', 'Revoke');"
													name="option1"
													value="Revocation Form Received and Validated">Revocation
												Form Received and Validated &nbsp; <br /> <br />
											</div>
											<div id="newValidationCheckBox" style="display: none;">
												<label>10-5345 Form Validation<img
													alt="Required field" src="res/star-icon_grey_bg.png" /><span
													style="display: none;">Form Validation required
														field</span>
												</label> <input id="newValidationCheckBoxInput" type="checkbox"
													alt="select Form Validation checkbox if New Authorization Form 10-5345 was received and validated. required field"
													onclick="enableRevokeAfterValidation('signatureDate','revokeAndAuthorize');"
													name="option1"
													value="New Authorization Form Received and Validated">New Authorization
												Form Received and Validated &nbsp; <br /> <br />

											</div>
											<div id="revokeDateAndUploadValidation" style="display: none;">
												<div>
													<label>Patient Signature Date<img
														alt="Required field" src="res/star-icon_grey_bg.png" /> <i><span
															style="display: none;"> Patient Signature Date
														required field</span><span style="font-weight: normal;">(mm/dd/yyyy)&nbsp;
														&nbsp;</span> </i> </label> <span style="display: none;">Patient
														Signature Date required field</span>
													<date:date id="signatureDate" name="signatureDate" onkeyup="enableRevokeAfterValidation('signatureDate', 'Revoke');"/>
													&nbsp; <br /> <br />
												</div>

												<c:choose>
													<c:when test="${isFormUploadAllowed}">
														<div>
															<label for="file">Upload Consent Form<br /> <i><span
																	style="font-weight: normal;">(Max file size:
																		${maxFileUploadSize/1000000} megabytes)</span> </i> </label><input
																alt="Browse and Upload Consent Form" name="uploaded"
																type="file" id="file" accept="application/pdf" />&nbsp;
														</div>
													</c:when>
												</c:choose>
											</div>
											<div id="revokeDateAndUploadValidationPatientDeceased" style="display: none;">
												<div>
													<label>Patient Deceased Date<img
														alt="Required field" src="res/star-icon_grey_bg.png" /> <i><span
															style="display: none;"> Patient Deceased Date
														required field</span><span style="font-weight: normal;">(mm/dd/yyyy)&nbsp;
														&nbsp;</span> </i> </label> <span style="display: none;">Patient
														Deceased Date required field</span>
													<date:date id="deceasedDate" name="deceasedDate" onkeyup="enableRevokeAfterValidation('deceasedDate', 'Revoke');"/>
													&nbsp; <br /> <br />
												</div>

												</div>
                                                                                        <div>
                                                                                            <label for="comments">Comments</label>
                                                                                            <span style="display: none;">Patient Comments not a required field</span>
                                                                                            <textarea id="comments" name="comments" style="width: 300px; height: 60px;"></textarea>
                                                                                            <br />
                                                                                        </div>
											<br />
											<div align="center" id='revokeButton' style="display:">
												<INPUT id="Revoke" alt="Revoke" class="button"
													disabled="disabled" TYPE="SUBMIT" VALUE="Revoke"
													name="optOut" onClick="enableAllElements()">
											</div>
											<div align="center" id="revokeAndAuthorizeButton" style="display: none;">
												<INPUT id="revokeAndAuthorize" alt="Revoke" class="button"
													disabled="disabled" TYPE="SUBMIT" VALUE="Revoke and Submit New Authorization"
													name="optOut" onClick="enableAllElements()">
											</div>
										</div>
									</form>
								</td>
							</tr>
						</table>
					</fieldset>
				</div>
			</td>
		</tr>
	</table>
</body>
</html>