<%--
    Document   : Sets the Default facility manually, or resets to automatic default facility
    Author     :               
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@page errorPage="error.jsp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Veterans Authorization & Preferences Set Default Facility</title>
<%@include file="metaCommon.jspf"%>
<script type="text/javascript" src="js/csspopup.js"></script>
<script type="text/javascript" src="js/errors.js"></script>
<script type="text/javascript">
	function doSubmit(form) {
		popup('processingDIV');
		return true;
	}
</script>
<script LANGUAGE="JavaScript">
function enableObject(arg) {
	var elmt = document.getElementById(arg);
	if (elmt != null) {
		elmt.disabled = false;
	}
}
function disableObject(arg) {
	var elmt = document.getElementById(arg);
	if (elmt != null) {
		elmt.disabled = true;
	}
}
function formShow(id) {
	var elmt = document.getElementById(id);
	if (elmt != null) {
		elmt.style.display = "";
	}
}
function formHide(id) {
	var elmt = document.getElementById(id);
	if (elmt != null) {
		elmt.style.display = "none";
	}
}
function checkState (){
	//only run the first time
	var state = '${facilityState}';
	newState (state);
	document.getElementById("facility").focus();
}
	
	function newState(currentState) {
		if (currentState == "manual") {
			//hide auto and none
			formHide('content-page-auto');
			formHide('content-page-none');
			formHide('content-page-label-auto');
			formHide('content-page-label-none');
			document.getElementById('removeManualFacility').disabled = false;
			//show manual state
			formShow('content-page-manual');
			formShow('content-page-label-manual');
		} else if (currentState == "auto") {
			//hide manual and none
			formHide('content-page-manual');
			formHide('content-page-none');
			formHide('content-page-label-manual');
			formHide('content-page-label-none');
			document.getElementById('removeManualFacility').disabled = true;
			//show auto state
			formShow('content-page-auto');
			formShow('content-page-label-auto');
		} else {
			//hide manual and auto
			formHide('content-page-manual');
			formHide('content-page-auto');
			formHide('content-page-label-manual');
			formHide('content-page-label-auto');
			document.getElementById('removeManualFacility').disabled = true;
			//show none state
			formShow('content-page-none');
			formShow('content-page-label-none');
		}
	}
</script>
</head>
<body onload="checkState()">
	<!-- START: HEADER CONTENT -->
	<%@include file="header.jspf"%>
	<!-- END: HEADER CONTENT -->
	<table border="0" cellpadding="0" cellspacing="0" width="100%"
		summary="table is used for layout purposes" id="main-content-table">
		<tbody>
			<tr>
				<%@include file="leftMenu.jspf"%>
				<td id="content-va"><a name="content-area"></a> <!-- START: SITE NAME BAR -->
					<p class="title-bar">
						<!-- START: SITE NAME -->
						Set Default Facility
						<!-- END: SITE NAME -->
					</p> <cpp:errors /> <!-- END: SITE NAME BAR -->
					<table border="0" cellpadding="0" cellspacing="0" width="100%"
						summary="table is used for layout purposes">
						<tbody>
							<tr>
								<td id="content-main">
									<table width="100%"
										summary="This table is used for layout purposes">
										<!-- START: PAGE TITLE AREA -->
										<!-- END: PAGE TITLE AREA -->
										<tr>
											<td>
												<!-- START: PAGE CONTENT -->
												<table SUMMARY="This table is for formatting purposes only.">
													<tbody>
														<tr id="content-page-manual" style = "display:none">
															<td id="content-page-content-title" width="100%"><font
																id="content-page-title-font">Your default
																	facility is manually set to ${visualDefaultUserFacility}
															</font></td>
														</tr>
														<tr id="content-page-auto" style = "display:none">
															<td id="content-page-content-title" width="100%"><font
																id="content-page-title-font">Your default
																	facility is automatically set to ${visualDefaultUserFacility},
																	based on your user ID.</font></td>
														</tr>
														<tr id="content-page-none" style = "display:none">
															<td id="content-page-content-title" width="100%"><font
																id="content-page-title-font">You do not currently
																	have a default facility.</font></td>
														</tr>
														<tr>
															<td>
																<table>
																	<tbody>
																		<tr id="content-page-label-manual" style = "display:none">
																			<td width="100%">To change your
																					default setting, choose a facility from the drop
																					down list and click Set Default Facility. To
																					remove your default setting and revert to the
																					automatic system setting, click Remove Default
																					Facility
																			</td>
																		</tr>
																		<tr id="content-page-label-auto" style = "display:none">
																			<td width="100%">To change your
																					default setting, choose a facility from the drop
																					down list and click Set Default Facility. *Note:
																					the option to remove the automatic system is not
																					available.
																			</td>
																		</tr>
																		<tr id="content-page-label-none" style = "display:none">
																			<td  width="100%">To set a default
																					Facility, choose a facility from the drop down list
																					and click Set Default Facility
																			</td>
																		</tr>
																	</tbody>
																</table>
															</td>
														</tr>
														<tr>
															<td>
																<div class="form-container">
																	<form name="setDefaultFacilityForm"
																		action="SetDefaultFacility.do_sec" method="POST"
																		onsubmit="return doSubmit(this)">
																		<div>
																			<label for="facility">VA Facility </label> <select
																				id="facility" name="facility">
																				<c:forEach var="f" items="${facilities}">
																					<option value="${f.facilityStation}"
																						<c:choose>
                                                     			<c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
	                                                        		 selected
	                                                        	</c:when>
                                                     			<c:when test="${cookie.facility.value == f.facilityStation}">
	                                                         		selected
	                                                         	</c:when>
                                                     		</c:choose>>
																						<c:choose>
																							<c:when test="${f.facilityName != ''}">
                                                         			${f.facilityName}
                                                       			</c:when>
																							<c:otherwise>
                                                         			${fn:split(f.facilityDns, '.')[0]}
                                                       			</c:otherwise>
																						</c:choose>
																						(${f.facilityStation})
																					</option>
																				</c:forEach>
																			</select>
																		</div>
																		</br>
																		<div class="buttonrow">
																			<input id="setManualFacility"
																				name="setManualFacility" alt="Set Default Facility"
																				class="button" type="submit"
																				value="Set Default Facility" /> <input
																				id="removeManualFacility"
																				name="removeManualFacility"
																				alt="Remove Default Facility" class="button"
																				type="submit" value="Remove Default Facility" />
																		</div>
																	</form>
																</div></td>
														</tr>
													</tbody>
												</table> <!-- END: PAGE CONTENT -->
											</td>
										</tr>
									</table></td>
							</tr>
						</tbody>
					</table> <!-- START: PAGE FOOTER --> <%@include file="footer.jspf"%>
					<!-- END: PAGE FOOTER --></td>
			</tr>
		</tbody>
	</table>
</body>
</html>
